*
*
* Compression et expansion d'images
*
* Par C.Tronche 1989 (87124)
*
* Commenc le 26/02/1989
*    v0.01 du 03/07/1989
*
* Logithque QLCF
*

         include ram1_qdos1_in
         include ram1_qdos2_in
         include ram1_qdosut_in

screen   equ $20000
current  equ -1
infinite equ -1

         lea newproc,a1                Chargement de la commande
         movea bp.init,a5
         jsr (a5)
         clr d0
         rts

newproc  dc.w 5
         dc.w normexpa-*
         dc.b 6,'EXPAND'
         dc.w fastexpa-*
         dc.b 10,'FASTEXPAND'
         DC.W COMPRESS-*
         DC.B 8,'COMPRESS'
         DC.W 0,0,0
         dc.w 0,0,0

normexpa movem.l d1-d7/a0-a6,-(sp)     Sauvegarde gnrale
         move.l #32768,d1         Ouvre la zone de chargement
         moveq #current,d2
         moveq #mt.alchp,d0
         trap #1
         tst d0
         bne norme_rt
         movea.l a0,a4            Sauve l'adresse de la zone dans a4
         move.l 40(sp),a3         Rcupre le pointeur de paramtres
         moveq #io.share,d5
         bsr ouvfic
         tst d0
         bne.s norme_r0
         movea.l a4,a1
         moveq #-1,d2             Charge tout le fichier
         moveq #infinite,d3
         moveq #fs.load,d0
         trap #3
         moveq #io.close,d0
         trap #2
         movea.l a4,a0
         movea.l #screen,a3       Travail directement dans l'cran
         move (a0)+,d7            Obtient l'adresse relative de la racine
         movea.l a0,a2
         movem.l d7/a2,-(sp)      Empile les paramtres
         movea.l a3,a1
         move #128,d0
         move #$100,d6
         tst d7
         bsr expand               Expansion
         moveq #0,d0              Retour
         adda #8,sp
norme_r0 move.l d0,-(sp)
         movea.l a4,a0
         moveq #mt.rechp,d0
         trap #1
         move.l (sp)+,d0
norme_rt movem.l (sp)+,d1-d7/a0-a6
         rts

fastexpa movem.l d1-d7/a0-a6,-(sp)     sauvegarde gnrale
         movea ca.gtlin,a0        Obtient les deux adresses
         jsr (a0)
         moveq #err.bp,d0
         subq #2,d3               Si on a pas deux paramtres,"bad parameter"
         bne.s faste_rt
         movea.l 0(a6,a1.l),a0    Adresse de dpart
         movea.l 4(a6,a1.l),a3    Zone de travail
         move (a0)+,d7            Obtient l'adresse relative de la racine
         movea.l a0,a2
         movem.l d7/a2,-(sp)      Empile les paramtres
         movea.l a3,a1
         move #128,d0
         move #$100,d6
         tst d7
         bsr expand               Expansion
         adda #8,sp               Libre la pile
         movea.l a3,a1
         movea.l #screen,a0       Recopie rapide de l'image expanse sur la vido
         move #2047,d0
trans_b1 move.l (a1)+,(a0)+
         move.l (a1)+,(a0)+
         move.l (a1)+,(a0)+
         move.l (a1)+,(a0)+
         dbra d0,trans_b1
         moveq #0,d0              Retour
faste_rt movem.l (sp)+,d1-d7/a0-a6
         rts

one_word move.b 0(a0,d7),(a1)           expansion d'une pseudo-couleur
         move.b 1(a0,d7),128(a1)
         rts

expand   bgt.s nextexpa                Si pointeur,appel rcursif
         move d6,d4
         sub d0,d4
         beq.s one_word
         subq #1,d0
         move d0,d1
         neg d7
         move.b 0(a0,d7),d2
         move.b 1(a0,d7),d3
         lea 128(a1),a2
expan.l1 move d0,d7
expan.l2 move.b d2,(a1)+
         move.b d3,(a2)+
         dbra d7,expan.l2
         adda d4,a1
         adda d4,a2
         dbra d1,expan.l1
         rts

nextexpa lsr #1,d0
         lea 0(a0,d7),a2
         movem.l a1/a2/d0,-(sp)
         move 6(a2),d7
         bsr.s expand
         movem.l (sp),d0/a1/a2
         adda d0,a1
         move (a2),d7
         bsr.s expand
         movem.l (sp),d0/a1/a2
         move d0,d1
         lsl #8,d1
         add d0,d1
         adda d1,a1
         move 4(a2),d7
         bsr.s expand
         movem.l (sp)+,d0/a1/a2
         move d0,d1
         lsl #8,d1
         adda d1,a1
         move 2(a2),d7
         bra.s expand

COMPRESS MOVEM.L D1-D7/A0-A6,-(SP)     Sauvegarde gnrale
         MOVEQ #IO.NEW,D5
         bsr ouvfic
         TST D0
         BNE.S EXIT2
         MOVEA.L A0,A5                 Sauve l'identificateur dans A5
         move.l #$10000,d1             Demande une zone de 64 K
         moveq #current,d2
         moveq #mt.alchp,d0
         trap #1
         tst d0
         bne.s exit3
         movea.l a0,a3                 Sauve le dbut de la zone de travail
         MOVEA.L A0,A2                 Rcupre l'identificateur
         MOVE.L #SCREEN,-(SP)          Paramtre de compression:adresse de dpart
         MOVE #32768,-(SP)             Passage  la zone horizontale suivante
         MOVE #128,-(SP)               Passage  la zone verticale suivante
         BSR EQUAL                     Compresse la zone
         ADDA #8,SP                    Nettoie la pile
         MOVEQ #ERR.BO,D0
         MOVE.L A0,D6
         SUB.L A2,D6
         CMPI.L #32768,D6              Si image compresse>32 K,fin
         BGT.S EXIT
         MOVE D7,D1                    Sinon sauve la taille de l'image (pointeur
         LSR #8,D1                       vers la racine de l'arbre)
         MOVEA.L A5,A0
         MOVEQ #INFINITE,D3
         MOVEQ #IO.SBYTE,D0
         TRAP #3
         TST D0
         BNE.S EXIT
         MOVE.B D7,D1
         MOVEQ #IO.SBYTE,D0
         TRAP #3
         TST D0
         BNE.S EXIT
         MOVEA.L A2,A1                 Sauve enfin l'image
         MOVE.L D6,D2
         MOVEQ #FS.SAVE,D0
         TRAP #3
EXIT     move.l d0,-(sp)
         movea.l a0,a5
         movea.l a3,a0
         moveq #mt.rechp,d0
         trap #1
         movea.l a5,a0
         move.l (sp)+,d0
exit3    MOVE.L D0,-(SP)
         MOVEQ #IO.CLOSE,D0
         TRAP #2
         MOVE.L (SP)+,D0
EXIT2    MOVEM.L (SP)+,D1-D7/A0-A6
         RTS

* Compression: compare rcursivement chaque groupe de 4 zones;si elles sont
* identiques,elles sont remplaces par un seul pointeur vers une cellule de la
* pseudo-couleur correspondante;cellule qui est cherche dans l'arbre est cre si
* aucune valeur ne fait l'affaire.

EQUAL    MOVE 4(SP),D0       Rcupre la taille horizontale
         MOVE 6(SP),D1       Et verticale
         MOVEA.L 8(SP),A1    Pointe le dbut de la zone
         CMP #1,D0           Est-on  une feuille terminale (pseudo-pixel) ?
         BEQ EQUAL.L2          oui,suite
         SUBQ #6,SP          Non,divise la zone en quatre,et refait la mme
         LSR #1,D0             opration sur chacune des zones
         LSR #1,D1
         MOVE.L A1,-(SP)     (calcul des dbuts de zones et empilement des paramtres)
         MOVEM D0/D1,-(SP)
         ADDA D0,A1
         MOVE.L A1,-(SP)
         MOVEM D0/D1,-(SP)
         ADDA D1,A1
         MOVE.L A1,-(SP)
         MOVEM D0/D1,-(SP)
         SUBA D0,A1
         MOVE.L A1,-(SP)
         MOVEM D0/D1,-(SP)
         BSR.S EQUAL         Appel rcursif
         ADDA #8,SP          Au retour:nettoie la pile pour la premire zone
         MOVE D7,26(SP)      Lit la pseudo-couleur associe (ou le pointeur)
         BSR.S EQUAL         De mme pour les quatres zones
         ADDA #8,SP
         MOVE D7,20(SP)
         BSR.S EQUAL
         ADDA #8,SP
         MOVE D7,8(SP)
         BSR.S EQUAL
         ADDA #8,SP
         MOVEM (SP)+,D2-D4
         TST D7              Si ce ne sont pas des couleurs,stocke les pointeurs
         BGT.S EQUAL.L3        de mme si les pseudo-couleurs (ou pointeurs) sont
         CMP D2,D7             diffrents
         BNE.S EQUAL.L3
         CMP D3,D7
         BNE.S EQUAL.L3
         CMP D4,D7
         BNE.S EQUAL.L3
         RTS

* Cas de 4 zones diffrentes

EQUAL.L3 movea.l a3,A1       Recherche un pointeur ou une pseudo-couleur de mme
SEARCHPO CMPA.L A0,A1          valeur
         BGE.S NOTFOUND
         CMP (A1)+,D2
         BNE.S SEARCHPO
         CMP (A1)+,D3
         BNE.S SEARCHPO
         CMP (A1)+,D4
         BNE.S SEARCHPO
         CMP (A1),D7
         BNE.S SEARCHPO
         CMPA.L A0,A1
         BGE.S NOTFOUND
         SUBQ #6,A1
         SUBA.L A2,A1
         MOVE A1,D7
         RTS

* Cas d'un groupe de pointeurs inexistant dans la liste

NOTFOUND MOVEM D2-D4/D7,(A0) Stocke les pointeurs
         MOVE.L A0,D7        Relativise le pointeur qui les pointe (!) et qui
         SUB.L A2,D7           sera renvoy comme rsultat dans D7
         ADDA #8,A0          Pointe la prochaine cellule vide
         RTS

* Cas du niveau pseudo-pixel

EQUAL.L2 MOVE.B (A1),D7
         EORI.B #-1,(A1)     Pour suivre la progression...
         LSL #8,D7           Cre la pseudo couleur:un groupe de huit bits et l'autre
         MOVE.B 128(A1),D7     groupe dans la ligne au-dessous
         movea.l a3,a1
         MOVE.L A0,D5
         SUB.L A1,D5
         LSR #1,D5
         SUBQ #1,D5
         BLT.S NOTCOLOR
FINDCOLO CMP (A1)+,D7        Recherche le mme mot dans la mmoire
         DBEQ D5,FINDCOLO
         BNE.S NOTCOLOR
         SUBQ #2,A1
         SUBA.L A2,A1
         MOVE A1,D7
         NEG D7
         RTS

* Cas d'une nouvelle couleur

NOTCOLOR MOVE D7,(A0)
         MOVE.L A0,D7
         ADDQ #2,A0
         movea.l a3,A1
         SUB.L A1,D7
         NEG D7
         RTS

* Ouverture de fichier

OUVFIC   MOVE.B 1(A6,A3.L),D1
         AND.B #$F,D1
         CMP.B #1,D1
         BNE.S PLNOVA
         MOVEA ca.gtstr,A2
         JSR (A2)
         SUBQ #1,D3
         beq.s ouvfi2
bpoufi   moveq #err.bp,d0
ERROFI   RTS
PLNOVA   SUBQ.B #2,D1
         BNE.S BPOUFI
         MOVE 2(A6,A3.L),D0
         LSL #3,D0
         MOVEA.L $18(A6),A0
         ADDA D0,A0
         MOVE 2(A6,A0.L),D0
         MOVEA.L $20(A6),A0
         ADDA D0,A0
         LEA 0(A6,A0.L),A0
         MOVE.B (A0)+,D1
         BEQ.S BPOUFI
         CMP.B #32,D1
         BHI.S BPOUFI
         EXT D1
         MOVE D1,D4
         ADDQ #3,D1
         BCLR #0,D1
         EXT D1
         EXT.L D1
         movea bv.chrix,a1
         JSR (A1)
         cmp.b #err.om,d0
         BEQ.S ERROFI
         MOVEA.L $58(A6),A1
         LEA 0(A6,A1.L),A2
         MOVE D4,(A2)+
         SUBQ #1,D4
TRAFIL   MOVE.B (A0)+,(A2)+
         DBRA D4,TRAFIL
OUVFI2   LEA 0(A6,A1.L),A0
         moveq #current,d1
         MOVE.L D5,D3
         moveq #io.open,d0
         TRAP #2
         RTS

         end

