* Hyperbolische Funktionen nach einer Idee aus den Advanced User Guide
* von
* Marc Wiemers
* Genter Str. 12
* W-1000 Berlin 65
* zur freien Verwendung

          include   win1_asm_lib_QDOSmini_in

BV_RIP    EQU       $58

* contents of RI stack

RIS_VAL   EQU       -6
RIS_1.0   EQU       -12
RIS_0.5   EQU       -18
RIS_EXP   EQU       -24

          section code

          lea       proc_tab,a1
          move.w    BP.INIT,a2
          jsr       (a2)
          moveq     #$00,d0
          rts

proc_tab
          dc.w      0
          dc.w      0
          dc.w      1
          dc.w      sinh-*
          dc.b      4,'SINH',0
          dc.w      cosh-*
          dc.b      4,'COSH',0
          dc.w      tanh-*
          dc.b      4,'TANH',0
          dc.w      coth-*
          dc.b      4,'COTH',0
          dc.w      arsinh-*
          dc.b      6,'ARSINH',0
          dc.w      arcosh-*
          dc.b      6,'ARCOSH',0
          dc.w      artanh-*
          dc.b      6,'ARTANH',0
          dc.w      arcoth-*
          dc.b      6,'ARCOTH',0
          dc.w      00

sinh
          bsr.s     holen
          bne.s     hyp_rts
          lea       sinh_tab,a3         ;set up operation table
          bsr.s     setzen
          bra       rechnen
cosh
          bsr.s     holen
          bne.s     hyp_rts
          lea       cosh_tab,a3         ;set up operation table
          bsr.s     setzen
          bra       rechnen
tanh
          bsr.s     holen
          bne.s     hyp_rts
          lea       tanh_tab,a3         ;set up operation table
          bsr.s     setzen
          bra       rechn
coth
          bsr.s     holen
          bne.s     hyp_rts
          lea       coth_tab,a3         ;set up operation table
          bsr.s     setzen
          bra       rechn
arsinh
          bsr.s     holen
          bne.s     hyp_rts
          lea       arsinh_tab,a3         ;set up operation table
          bsr.s     setz
          bra.s     rechnen
arcosh
          bsr.s     holen
          bne.s     hyp_rts
          lea       arcosh_tab,a3         ;set up operation table
          bsr.s     setz
          bra.s     rechnen
artanh
          bsr.s     holen
          bne.s     hyp_rts
          lea       artanh_tab,a3         ;set up operation table
          bsr.s     setzen
          bra.s     rechnen
arcoth
          bsr.s     holen
          bne.s     hyp_rts
          lea       arcoth_tab,a3         ;set up operation table
          bsr.s     setzen
          bra.s     rechnen

******************

holen     moveq     #72,d1              ;reserve space for 12
          move.w    BV.CHRIX,a2         ;floating point numbers
          jsr       (a2)

          move.w    CA.GTFP,a2          ;get any number of floating
          jsr       (a2)                ;point numbers
          bne.s     hyp_rts             ;..... oops
          subq.w    #1,d3               ;but we only wanted one
          bne.s     ERR_BP
hyp_rts
          rts

err_bp
          moveq     #ERR.BP,d0
          rts

*******************
setzen
          lea       6(a1),a4            ;set top of stack pointer
          clr.w     -2(a6,a1.l)         ;put 1.0 on
          move.l    #$08014000,-6(a6,a1.l)
          clr.w     -8(a6,a1.l)         ;put 0.5 on
          move.l    #$08004000,-12(a6,a1.l)
          rts
********************
setz
          lea       6(a1),a4            ;set top of stack pointer
          clr.w     -2(a6,a1.l)         ;put 1.0 on
          move.l    #$08014000,-6(a6,a1.l)
          clr.w     -8(a6,a1.l)         ;put 2.0 on
          move.l    #$08024000,-12(a6,a1.l)
          rts

********************

rechnen
          moveq     #$00,d7
          sub.w     #12,a1
          move.w    RI.EXECB,a2         ;now use arithmetic package
          jsr       (a2)
          add.w     #12,a1              ;reset arithmetic stack
          move.l    a1,BV_RIP(a6)
          moveq     #2,d4               ;and set type
          rts
********************
rechn
          moveq     #$00,d7
          sub.w     #12,a1
          move.w    RI.EXECB,a2         ;now use arithmetic package
          jsr       (a2)
          add.w     #18,a1              ;reset arithmetic stack
          move.l    a1,BV_RIP(a6)
          moveq     #2,d4               ;and set type
          rts

*********************
* sinh(x) = (exp(x)-exp(-x))/2

sinh_tab
          dc.b      RIS_VAL             ;Stack    x
          dc.b      RI.EXP              ;exp(x)
          dc.b      RIS_1.0             ;exp(x),1.0
          dc.b      RIS_EXP             ;exp(x),1.0,exp(x)
          dc.b      RI.DIV              ;exp(x),exp(-x)
          dc.b      RI.SUB              ;exp(x)-exp(-x)
          dc.b      RIS_0.5             ;exp(x)-exp(x),0.5
          dc.b      RI.MULT             ;(exp(x)-exp(x)*0.5
          dc.b      RIS_VAL+RI.STORE
          dc.b      0

* cosh(x) = (exp(x)+exp(-x))/2

cosh_tab
          dc.b      RIS_VAL             ;Stack    x
          dc.b      RI.EXP              ;exp(x)
          dc.b      RIS_1.0             ;exp(x),1.0
          dc.b      RIS_EXP             ;exp(x),1.0,exp(x)
          dc.b      RI.DIV              ;exp(x),exp(-x)
          dc.b      RI.ADD              ;exp(x)+exp(-x)
          dc.b      RIS_0.5             ;exp(x)-exp(x),0.5
          dc.b      RI.MULT             ;(exp(x)-exp(x)*0.5
          dc.b      RIS_VAL+RI.STORE
          dc.b      0

* tanh(x) = (exp(x)-exp(-x))/(exp(x)+exp(-x))

tanh_tab
          dc.b      RIS_VAL             ;Stack->TOS(x)
          dc.b      RI.EXP              ;exp(x)
          dc.b      RI.DUP              ;exp(x),exp(x)
          dc.b      RIS_1.0             ;exp(x),exp(x),1.0
          dc.b      RIS_EXP             ;exp(x),exp(x),1.0,exp(x)
          dc.b      RI.DIV              ;exp(x),exp(x),exp(-x)
          dc.b      RI.SUB              ;exp(x),exp(x)-exp(-x)
          dc.b      RIS_EXP             ;exp(x),exp(x)-exp(-x),exp(x)
          dc.b      RIS_1.0             ;exp(x),exp(x)-exp(-x),exp(x),1.0
          dc.b      RIS_EXP             ;exp(x),exp(x)-exp(-x),exp(x),1.0,exp(x)
          dc.b      RI.DIV              ;exp(x),exp(x)-exp(-x),exp(x),exp(-x)
          dc.b      RI.ADD              ;exp(x),exp(x)-exp(-x),exp(x)+exp(-x)
          dc.b      RI.DIV              ;exp(x),exp(x)-exp(-x),exp(x)+exp(-x)
          dc.b      RIS_VAL+RI.STORE
          dc.b      0

* coth(x) = (exp(x)+exp(-x))/(exp(x)-exp(-x))

coth_tab
          dc.b      RIS_VAL             ;Stack x
          dc.b      RI.EXP              ;exp(x)
          dc.b      RI.DUP              ;exp(x),exp(x)
          dc.b      RIS_1.0             ;exp(x),exp(x),1.0
          dc.b      RIS_EXP             ;exp(x),exp(x),1.0,exp(x)
          dc.b      RI.DIV              ;exp(x),exp(x),exp(-x)
          dc.b      RI.ADD              ;exp(x),exp(x)+exp(-x)
          dc.b      RIS_EXP             ;exp(x),exp(x)+exp(-x),exp(x)
          dc.b      RIS_1.0             ;exp(x),exp(x)+exp(-x),exp(x),1.0
          dc.b      RIS_EXP             ;exp(x),exp(x)+exp(-x),exp(x),1.0,exp(x)
          dc.b      RI.DIV              ;exp(x),exp(x)+exp(-x),exp(x),exp(-x)
          dc.b      RI.SUB              ;exp(x),exp(x)+exp(-x),exp(x)-exp(-x)
          dc.b      RI.DIV              ;exp(x),exp(x)+exp(-x),exp(x)-exp(-x)
          dc.b      RIS_VAL+RI.STORE
          dc.b      0

* arsinh(x) = ln(x+sqrt(x^2+1))

arsinh_tab
          dc.b      RIS_VAL             ;Stack x
          dc.b      RIS_0.5             ;x,2
          dc.b      RI.POWFP            ;x^2
          dc.b      RIS_1.0             ;x^2,1
          dc.b      RI.ADD              ;x^2+1
          dc.b      RI.SQRT             ;sqrt(x^2+1)
          dc.b      RIS_VAL             ;sqrt(x^2+1),x
          dc.b      RI.ADD              ;sqrt(x^2+1)+x
          dc.b      RI.LN               ;ln(sqrt(x^2+1)+x)
          dc.b      RIS_VAL+RI.STORE
          dc.b      0

* arcosh(x) = ln(x+sqrt(x^2-1))

arcosh_tab
          dc.b      RIS_VAL             ;Stack x
          dc.b      RIS_0.5             ;x,2
          dc.b      RI.POWFP            ;x^2
          dc.b      RIS_1.0             ;x^2,1
          dc.b      RI.SUB              ;x^1-1
          dc.b      RI.SQRT             ;sqrt(x^2-1)
          dc.b      RIS_VAL             ;sqrt(x^2-1),x
          dc.b      RI.ADD              ;sqrt(x^2-1)+x
          dc.b      RI.LN               ;ln(sqrt(x^2-1)+x)
          dc.b      RIS_VAL+RI.STORE
          dc.b      0

* artanh(x) = 0.5*ln((1+x)/(1-x))

artanh_tab
          dc.b      RIS_1.0             ;1.0
          dc.b      RIS_VAL             ;1.0,x
          dc.b      RI.ADD              ;1+x
          dc.b      RIS_1.0             ;1+x,1
          dc.b      RIS_VAL             ;1+x,1,x
          dc.b      RI.SUB              ;1+x,1-x
          dc.b      RI.DIV              ;(1+x)/(1-x)
          dc.b      RI.LN               ;ln(1+x)/(1-x)
          dc.b      RIS_0.5             ;ln(1+x)/(1-x),0.5
          dc.b      RI.MULT             ;ln(1+x)/(1-x)*0.5
          dc.b      RIS_VAL+RI.STORE
          dc.b      0

* arcoth(x) = 0.5*ln((x+1)/(x-1))

arcoth_tab
          dc.b      RIS_VAL             ;Stack x
          dc.b      RIS_1.0             ;x,1
          dc.b      RI.ADD              ;x+1
          dc.b      RIS_VAL             ;x+1,x
          dc.b      RIS_1.0             ;x+1,x,1
          dc.b      RI.SUB              ;x+1,x-1
          dc.b      RI.DIV              ;(x+1)/(x-1)
          dc.b      RI.LN               ;ln(x+1)/(x-1)
          dc.b      RIS_0.5             ;ln(x+1)/(x-1),0.5
          dc.b      RI.MULT             ;ln(x+1)/(x-1)*0.5
          dc.b      RIS_VAL+RI.STORE
          dc.b      0

          End
