begin      lea.l    define,a1         Link in new BASIC commands
           move.w   $110,a2            then return to BASIC
           jmp      (a2)

define     dc.w     1                 One procedure
           dc.w     start-*            - begins at 'start'
           dc.b     6,'S_FONT'         - is called 'S_FONT'
           dc.w     0
           dc.w     0
           dc.w     0

START      BSR.S    GET_PARAS         Fetch first parameter
           BNE.S    BAD_INT
           BSR.S    GET_PAR2          Get second parameter
           SUBA.L   A2,A2
           SUBQ.W   #1,D3             Only one font to be set ?
           BEQ.S    FONT2             Yes, then set it
           SUBQ.W   #1,D3             No more than two fonts can be set!
           BNE.S    BAD_ENT           Oops - too many fonts.
           MOVE.L   $4(A1,A6.L),A2    Store second font address.

FONT2      MOVE.L   $0(A1,A6.L),A1    Store first font address.
           MOVEQ    #$25,D0
           MOVEQ    #-1,D3            This Job.
           TRAP     #3                Set the new font address.
           TST.L    D0                An error?
           RTS

GET_PAR2   MOVE.W   $118,A2           Fetch the base of new font.
           JSR      (A2)
           BNE.S    BAD_PAR           Oops.
           RTS

GET_INTS   MOVE.W   $112,A2           Fetch the integer channel number.
           MOVEQ    #$F,D6
           AND.B    $F9(A6,A5.L),D6
           JSR      (A2)
           MOVE.B   D6,$F9(A6,A5.L)
           TST.L    D0                Any error?
           BEQ.S    BAD_INT           Oops.

BAD_PAR    ADDQ.L   #4,A7             Return from here to BASIC.

BAD_ENT    MOVEQ    #-15,D0           Bad Parameter error.

BAD_INT    RTS                        Return.

GET_PARAS  CMPA.L   A5,A3             Any channel number?
           BEQ.S    NO_PARAM          No, sorry.
           TST.B    $1(A3,A6.L)       Is there a hash symbol?
           BMI.S    GET_CHAN          Yes, so find channel.

NO_PARAM   MOVEQ    #1,D1             Default channel = #1
           BRA.S    GET_START

GET_CHAN   MOVE.L   A5,D5             Store parameter number.
           LEA.L    $8(A3),A5         Get rid of Hash.
           BSR.S    GET_INTS          Get the channel number.
           MOVE.L   A5,A3
           MOVE.L   D5,A5             Restore the parameter number.

CALC_CHAN  MOVE.W   $0(A1,A6.L),D1    Get BASIC channel number
           ADDQ.L   #2,A1              now to convert it to QL's internal
           MOVE.L   A1,$58(A6)         channel number.

GET_START  MULU     #$28,D1           Point to channel table.
           ADD.L    $30(A6),D1
           CMP.L    $34(A6),D1        Is it within the table?
           BGE.S    ERR_NO            No
           MOVE.L   $0(A6,D1.L),D0    Is channel open?
           BMI.S    ERR_NO            No
           MOVE.L   D0,A0             Store channel number
           MOVEQ    #0,D0             No error
           RTS

ERR_NO     MOVEQ    #-6,D0            Signify channel not open.
           ADDQ.L   #4,A7             Return to BASIC from here.
           RTS

           END
