;                   PTR_X : fonction SUPERBASIC renvoyant la partie
;                           relle d'un nombre complexe (x)
;                   PTR_Y : fonction SUPERBASIC renvoyant la partie
;                           imaginaire d'un nombre complexe (y)
;                   RTP_R : fonction SUPERBASIC renvoyant le module d'un
;                           nombre complexe (rayon)
;                   RTP_T : fonction SUPERBASIC renvoyant l'argument d'un
;                           nombre complexe (thta)

;                   utilisation :

;                           part_relle = PTR_X(argument,module)
;                           part_imag   = PTR_Y(argument,module)
;                           module      = RTP_R(part_relle,part_imag)
;                           argument    = RTP_T(part_relle,part_imag)


bv_rip              equ       $58
ri_add              equ       $0a
ri_sub              equ       $0c
ri_mult             equ       $0e
ri_div              equ       $10
ri_neg              equ       $14
ri_dup              equ       $16
ri_cos              equ       $18
ri_sin              equ       $1a
ri_atan             equ       $24
ri_root             equ       $28


                    move.w    bp_init,a0
                    lea       TABLE,a1
                    jsr       (a0)
                    rts

PTR_X               moveq     #ri_cos,d7
                    bra.s     DEB_PTR
PTR_Y               moveq     #ri_sin,d7

DEB_PTR             bsr.s     SAISIE_PARAMETRES
                    bne.s     ERREUR_BP

                    move.b    8(a6,a1.l),d5       Le module doit tre
                    bmi.s     ERREUR_BP           positif...

                    move.w    d7,d0
                    jsr       (a0)                COS(t) ou SIN(t)
                    bne.s     ERREUR

                    moveq     #ri_mult,d0         r*COS(t) ou r*SIN(t)
                    jsr       (a0)

                    bra.s     SORTIE

RTP_R               bsr.s     SAISIE_PARAMETRES
                    bne.s     ERREUR_BP

                    move.l    2(a6,a1.l),d5
                    or.l      8(a6,a1.l),d5
                    beq.s     ERREUR_BP           x = y = 0

                    move.w    bv_chrix,a2         Rserve 6 octets sur la
                    moveq     #6,d1               pile arithmtique
                    jsr       (a2)
                    move.l    bv_rip(a6),a1

                    bsr.s     CARRE               x^2
                    bne.s     ERREUR

                    move.w    0(a6,a1.l),d5       Sauve la valeur
                    move.l    2(a6,a1.l),d6
                    add.l     #6,a1

                    bsr.s     CARRE               y^2
                    bne.s     ERREUR

                    sub.l     #6,a1               Rcupre la valeur
                    move.w    d5,0(a6,a1.l)       pralablement sauve
                    move.l    d6,2(a6,a1.l)

                    moveq     #ri_add,d0          x^2+y^2
                    jsr       (a0)
                    bne.s     ERREUR

                    moveq     #ri_root,d0         SQRT(x^2+y^2)
                    jsr       (a0)

SORTIE              move.l    a1,bv_rip(a6)       Pointe le rsultat
                    moveq     #2,d4               Type = flottant
ERREUR              rts
ERREUR_BP           moveq     #err_bp,d0
                    rts

CARRE               moveq     #ri_dup,d0          TOS^2
                    jsr       (a0)
                    moveq     #ri_mult,d0
                    jmp       (a0)

SAISIE_PARAMETRES   move.w    ca_gtfp,a0
                    jsr       (a0)
                    bne.s     ERREUR
                    sub.w     #2,d3               La fonction n'accepte
                    bne.s     ERREUR              que deux paramtres

                    move.w    ri_exec,a0          Opration arithmtique
                    rts

RTP_T               bsr.s     SAISIE_PARAMETRES
                    bne.s     ERREUR_BP

                    move.l    #$6487ed51,d7       Mantisse de PI
                    move.l    8(a6,a1.l),d6          "     "  y
                    move.l    2(a6,a1.l),d5          "     "  x
                    bne.s     DIFF_ZERO
                    tst.l     d6
                    beq.s     ERREUR_BP           x = y = 0

                    add.l     #6,a1
                    move.w    #$0801,0(a6,a1.l)   +PI/2
                    move.l    d7,2(a6,a1.l)

                    tst.l     d6
                    bpl.s     SORTIE

                    moveq     #ri_neg,d0          -PI/2
                    jsr       (a0)

                    bra.s     SORTIE

DIFF_ZERO           moveq     #ri_div,d0          y/x
                    jsr       (a0)
                    bne.s     ERREUR

                    moveq     #ri_atan,d0         ATAN(y/x)
                    jsr       (a0)
                    bne.s     ERREUR

                    tst.l     d5
                    bpl.s     SORTIE              Cadrans 1 & 4

                    sub.l     #6,a1
                    move.w    #$0802,0(a6,a1.l)   PI
                    move.l    d7,2(a6,a1.l)

                    moveq     #ri_add,d0          Cadran 2
                    tst.l     d6
                    bpl.s     VECTEUR
                    moveq     #ri_sub,d0          Cadran 3
VECTEUR             jsr       (a0)

                    bra.s     SORTIE

TABLE               dc.w      0,0,4
                    dc.w      PTR_X-*
                    dc.b      5,"PTR_X"
                    dc.w      PTR_Y-*
                    dc.b      5,"PTR_Y"
                    dc.w      RTP_R-*
                    dc.b      5,"RTP_R"
                    dc.w      RTP_T-*
                    dc.b      5,"RTP_T"
                    dc.w      0

                    END
