start   lea     tab,a1
        move.w  $110,a0
        jsr     (a0)
        rts
tab     dc.w    14
        dc.w    shape-*
        dc.b    5,'SHAPE'       ;SHAPE linearray,pointarray,lines
        dc.w    trans-*
        dc.b    6,'LINEAR',0    ;LINEAR pointarray,xstep,ystep,points
        dc.w    points-*
        dc.b    6,'PUNKTE',0    ;PUNKTE pointarray,points,colour
        dc.w    rotate2-*
        dc.b    7,'ROTATE2'     ;ROTATE2 pointarray,x,y,points,winkel
        dc.w    double-*
        dc.b    6,'DOUBLE',0    ;DOUBLE address1,address2,points
        dc.w    inbet-*
        dc.b    9,'INBETWEEN'   ;INBETWEEN punkte1,punkte2,linearray,lines,steps
        dc.w    press-*
        dc.b    5,'PRESS'       ;PRESS punktarray,xpress,ypress,points
        dc.w    limit-*
        dc.b    5,'LIMIT'       ;LIMIT xmin,xmax,ymin,ymax
        dc.w    mx2-*
        dc.b    8,'MIRRORX2',0  ;MIRRORX2 pointarray,xachse,points
        dc.w    my2-*
        dc.b    8,'MIRRORY2',0  ;MIRRORY2 pointarray,yachse,points
        dc.w    mp-*
        dc.b    7,'MIRROR2'     ;MIRROR2 pointarray,xachse,yachse,points
        dc.w    demo-*
        dc.b    4,'DEMO',0      ;DEMO repetition
        dc.w    apoint-*
        dc.b    6,'APOINT',0    ;APOINT x,y,colour
        dc.w    aline-*
        dc.b    5,'ALINE'       ;ALINE x0,y0,x1,y1,colour
        dc.w    0,0,0

shape   move.w  $118,a0
        jsr     (a0)
        tst.w   d0
        bne     err_bp
        subq.w  #3,d3
        bne     err_bp
        trap    #0
        move.w  #$2700,sr
        move.l  0(a6,a1.l),a5   ;Addresse des Linearrays
        move.l  4(a6,a1.l),a4   ;Addresse des Punktarrays
        move.l  8(a6,a1.l),d7   ;Anzahl der Linien
        subq.w  #1,d7
        bmi     err_bp
loop    move.w  (a5),d5                 ;1. Punkt
        ext.l   d5
        lsl.l   #2,d5
        move.w  0(a4,d5.l),d0           ;x0
        move.w  2(a4,d5.l),d1           ;y0
        move.w  2(a5),d5                ;2. Punkt
        ext.l   d5
        lsl.l   #2,d5
        move.w  0(a4,d5.l),d2           ;x1
        move.w  2(a4,d5.l),d3           ;y1
        move.w  4(a5),d5                ;Farbe
        and.w   #7,d5
        lsl.w   #1,d5
        lea     farbe,a1
        move.w  0(a1,d5.w),d6
        lea     6(a5),a5
        move.l  d7,-(a7)
        bsr     line
        move.l  (a7)+,d7
        dbf     d7,loop
        moveq   #0,d0
        move.w  #0,sr
        rts

trans   move.w  $118,a0
        jsr     (a0)
        tst.w   d0
        bne     err_bp
        subq.w  #4,d3
        bne     err_bp
        move.l  0(a6,a1.l),a0   ;Punkttabelle
        move.l  4(a6,a1.l),d0   ;xstep
        move.l  8(a6,a1.l),d1   ;ystep
        move.l  12(a6,a1.l),d7  ;Anzahl Punkte
        subq.l  #1,d7
tloop   add.w   d0,(a0)+
        add.w   d1,(a0)+
        dbf     d7,tloop
        moveq   #0,d0
        rts

points  move.w  $118,a0
        jsr     (a0)
        tst.w   d0
        bne     err_bp
        subq.w  #3,d3
        bne     err_bp
        move.l  0(a6,a1.l),a3           ;Punktarray
        move.l  4(a6,a1.l),d7           ;Anzahl Punkte
        move.l  8(a6,a1.l),d5           ;Farbe
        and.w   #7,d5
        lea     farbe,a1
        lsl.w   #1,d5
        move.w  0(a1,d5.w),d6
        subq.w  #1,d7
        lea     $20000,a0
ploop   move.w  (a3)+,d0        ;x-Koordinate
        move.w  (a3)+,d1        ;y-Koordinate
        jsr     punkt
        dbf     d7,ploop
        moveq   #0,d0
        rts

rotate2 move.w  $118,a0
        jsr     (a0)
        tst.l   d0
        bne     err_bp
        subq.w  #5,d3
        bne     err_bp
        move.l  0(a6,a1.l),a0   ;Punktarray
        move.l  4(a6,a1.l),d6   ;Rotation um X
        move.l  8(a6,a1.l),d5   ;Rotation um Y
        move.l  12(a6,a1.l),d7  ;Anzahl der Punkte
        move.l  16(a6,a1.l),d4  ;Winkel
falsch  sub.w   #360,d4         ;Winkel >=0 und <360
        bpl.s   falsch
        add.w   #360,d4
        lea     sin,a1          ;Wert aus Tabelle holen
        lsl.w   #2,d4
        move.w  0(a1,d4.w),d2   ;sin holen
        move.w  2(a1,d4.w),d1   ;cos holen
        subq.w  #1,d7
        moveq   #14,d4
floop1  move.w  (a0),d0         ;x-Wert holen
        move.w  d0,a2
        sub.w   d6,d0
        muls    d1,d0           ;x=x*cos*16384
        move.w  2(a0),d3
        sub.w   d5,d3
        muls    d2,d3           ;y=y*sin*16384
        add.l   d3,d0           ;x=x+y
        lsr.l   d4,d0           ;x=x/16384
        add.w   d6,d0
        move.w  d0,(a0)
        move.w  a2,d0           ;x_wert holen
        sub.w   d6,d0
        muls    d2,d0           ;x=x*sin*16384
        move.w  2(a0),d3        ;y-Wert holen
        sub.w   d5,d3   
        muls    d1,d3           ;y=y*cos*16384
        sub.l   d0,d3           ;y=x-y
        lsr.l   d4,d3           ;y=y/16384
        add.w   d5,d3
        move.w  d3,2(a0)
        addq.l  #4,a0
        dbf     d7,floop1
        moveq   #0,d0
        rts
        
double  move.w  $118,a0
        jsr     (a0)
        tst.w   d0
        bne     err_bp
        subq.w  #3,d3
        bne     err_bp
        move.l  0(a6,a1.l),a2
        move.l  4(a6,a1.l),a3
        move.l  8(a6,a1.l),d7
        subq.w  #1,d7
dloop   move.l  (a2)+,(a3)+
        dbf     d7,dloop
        moveq   #0,d0
        rts

inbet   move.w  $118,a0
        jsr     (a0)
        tst.w   d0
        bne     err_bp
        subq.w  #5,d3
        bne     err_bp
        trap    #0
        move.w  #$2700,sr
        move.l  0(a6,a1.l),a2           ;Punktarray1
        move.l  4(a6,a1.l),a3           ;Punktarray2
        move.l  8(a6,a1.l),a4           ;Linearray
        move.l  12(a6,a1.l),d6          ;Anzahl der Linien
        move.l  16(a6,a1.l),d7          ;Anzahl der Schritte
        moveq   #0,d5                   ;Hoechste Punktnummer
        subq.l  #1,d6                   ;feststellen
        move.l  d6,d1
        move.l  a4,a5
iloop   cmp.w   (a5),d5                 
        bge.s   ywert
        move.w  (a5),d5
ywert   cmp.w   2(a5),d5
        bge.s   eiloop
        move.w  2(a5),d5
eiloop  addq.l  #6,a5
        dbra    d1,iloop
        move.w  d5,-(a7)
        lea     platz,a5
        moveq   #0,d1           ;Offset fuer neuen Speicher
        moveq   #0,d2           ;Offset fuer Punktarray
cloop   move.w  0(a2,d2.w),d3
        ext.l   d3
        lsl.l   #8,d3
        move.l  d3,0(a5,d1.w)
        move.l  d3,8(a5,d1.w)
        move.w  2(a2,d2.w),d3
        ext.l   d3
        lsl.l   #8,d3
        move.l  d3,4(a5,d1.w)
        move.l  d3,12(a5,d1.w)
        addq.l  #4,d2
        add.l   #32,d1
        dbra    d5,cloop
        move.w  (a7),d5
        moveq   #0,d1           ;Offset fuer neuen Speicher
        moveq   #0,d2           ;Offset fuer 2. Punktarray
gloop   move.w  0(a3,d2.w),d3   ;Bestimmen des Inkrements
        ext.l   d3
        lsl.l   #8,d3
        sub.l   0(a5,d1.w),d3
        divs    d7,d3
        ext.l   d3
        move.l  d3,16(a5,d1.w)
        move.w  2(a3,d2.w),d3
        ext.l   d3
        lsl.l   #8,d3
        sub.l   4(a5,d1.w),d3
        divs    d7,d3
        ext.l   d3
        move.l  d3,20(a5,d1.w)
        addq.l  #4,d2
        add.l   #32,d1
        dbra    d5,gloop
        subq.l  #2,d7
        lea     farbe,a1
eloop   move.w  (a7),d1
        moveq   #0,d5    
hloop   move.l  8(a5,d5.l),d2
        move.l  d2,0(a5,d5.l)
        add.l   16(a5,d5.l),d2
        move.l  d2,8(a5,d5.l)
        move.l  12(a5,d5.l),d2
        move.l  d2,4(a5,d5.l)
        add.l   20(a5,d5.l),d2
        move.l  d2,12(a5,d5.l)
        add.l   #32,d5
        dbra    d1,hloop
        movem.l d6-d7,-(a7)
        jsr     draw
        movem.l (a7)+,d6-d7
        dbra    d7,eloop
        movem.l d6-d7,-(a7)
        jsr     loesch
        movem.l (a7)+,d6-d7
        move.w  (a7)+,d1
        move.l  d6,d7
        move.l  a4,a5
        move.l  a3,a4
        jmp     loop
        
press   move.w  $118,a0
        jsr     (a0)
        tst.w   d0
        bne     err_bp
        subq.w  #4,d3
        bne     err_bp
        move.l  0(a6,a1.l),a0           ;Punktarray
        move.l  4(a6,a1.l),d5           ;x-Faktor ( 512=1 )
        move.l  8(a6,a1.l),d6           ;y-Faktor ( 512=1 )
        MOVE.L  12(A6,A1.l),d7          ;Anzahl der Punkte
        subq.w  #1,d7
        moveq   #9,d2
prloop  move.w  (a0),d1
        muls    d5,d1
        lsr.l   d2,d1
        move.w  d1,(a0)+
        move.w  (a0),d1
        muls    d6,d1
        lsr.l   d2,d1
        move.w  d1,(a0)+
        dbra    d7,prloop
        moveq   #0,d0
        rts

limit   move.w  $118,a0
        jsr     (a0)
        tst.w   d0
        bne     err_bp
        subq.w  #4,d3
        bne     err_bp
        move.l  0(a6,a1.l),d0           ;xmin
        move.l  4(a6,a1.l),d1           ;xmax
        move.l  8(a6,a1.l),d2           ;ymin
        move.l  12(a6,a1.l),d3          ;ymax
        cmp.w   d0,d1
        bmi     err_bp
        cmp.w   d2,d3
        bmi     err_bp
        tst.w   d0
        bmi     err_bp
        tst.w   d2      
        bmi     err_bp
        cmp.w   #512,d1
        bpl     err_bp
        cmp.w   #256,d3
        bpl     err_bp
        lea     xmin,a0
        move.w  d0,(a0)+
        move.w  d1,(a0)+
        move.w  d2,(a0)+
        move.w  d3,(a0)+
        moveq   #0,d0
        rts

mx2     move.w  $118,a0
        jsr     (a0)
        tst.w   d0
        bne     err_bp
        subq.w  #3,d3
        bne     err_bp
        move.l  0(a6,a1.l),a0           ;Pointarray
        move.l  4(a6,a1.l),d6           ;x-Achse
        move.l  8(a6,a1.l),d7           ;y-Achse
        subq.w  #1,d7
mx2loop move.w  (a0),d1
        sub.w   d6,d1
        neg.w   d1
        add.w   d6,d1
        move.w  d1,(a0)
        addq.l  #4,a0
        dbra    d7,mx2loop
        moveq   #0,d0
        rts

my2     move.w  $118,a0
        jsr     (a0)
        tst.w   d0
        bne     err_bp
        subq.w  #3,d3
        bne     err_bp
        move.l  0(a6,a1.l),a0           ;Pointarray
        move.l  4(a6,a1.l),d6           ;y-Achse
        move.l  8(a6,a1.l),d7           ;Points
        subq.w  #1,d7
        lea     2(a0),a0
my2loop move.w  (a0),d1
        sub.w   d6,d1
        neg.w   d1
        add.w   d6,d1
        move.w  d1,(a0)
        addq.l  #4,a0
        dbra    d7,my2loop
        moveq   #0,d0
        rts

mp      move.w  $118,a0
        jsr     (a0)
        tst.w   d0
        bne     err_bp
        subq.w  #4,d3
        bne     err_bp
        move.l  0(a6,a1.l),a0           ;Pointarray
        move.l  4(a6,a1.l),d5           ;x-Achse
        move.l  8(a6,a1.l),d6           ;y-Achse
        move.l  12(a6,a1.l),d7          ;Points
        subq.w  #1,d7
mploop  move.w  (a0),d1
        sub.w   d5,d1
        neg.w   d1
        add.w   d5,d1
        move.w  d1,(a0)+
        move.w  (a0),d1
        sub.w   d6,d1
        neg.w   d1
        add.w   d6,d1
        move.w  d1,(a0)+
        dbra    d7,mploop
        moveq   #0,d0
        rts  

demo    move.w  $118,a0
        jsr     (a0)
        tst.w   d0
        bne     err_bp
        subq.w  #1,d3
        bne     err_bp
        move.l  0(a6,a1.l),d4
        move.w  #$8080,d6
sdemo   move.w  #$0000,d0
        move.w  #$0000,d1
        move.w  #$01ff,d2
        move.w  #$00ff,d3
deloop1 movem.l d0-d4,-(a7)
        bsr     line
        movem.l (a7)+,d0-d4
        addq.w  #1,d0
        dbra    d2,deloop1
        move.w  #$0000,d0
        move.w  #$00ff,d1
        move.w  #$01ff,d2
        move.w  #$0000,d3
deloop2 movem.l d0-d4,-(a7)
        bsr     line
        movem.l (a7)+,d0-d4
        addq.w  #1,d3
        dbra    d1,deloop2
        dbra    d4,sdemo
        moveq   #0,d0
        rts

apoint  move.w  $118,a0
        jsr     (a0)
        tst.w   d0
        bne     err_bp
        subq.w  #3,d3
        bne     err_bp
        move.l  0(a6,a1.l),d0
        move.l  4(a6,a1.l),d1
        move.l  8(a6,a1.l),d6
        andi.w  #7,d6
        lea     farbe,a0
        lsl.w   #1,d6
        move.w  0(a0,d6.w),d6
        jsr     punkt
        moveq   #0,d0
        rts

aline   move.w  $118,a0
        jsr     (a0)
        tst.w   d0
        bne     err_bp
        subq.w  #5,d3
        bne     err_bp
        trap    #0
        move.w  #$2700,sr
        move.l  0(a6,a1.l),d0
        move.l  4(a6,a1.l),d1
        move.l  8(a6,a1.l),d2
        move.l  12(a6,a1.l),d3
        move.l  16(a6,a1.l),d6
        andi.w  #7,d6
        lsl.w   #1,d6
        lea     farbe,a0
        move.w  0(a0,d6.w),d6
        jsr     line
        moveq   #0,d0
        move.w  d0,sr
        rts

err_bp  moveq   #-15,d0
        rts

draw    moveq   #0,d5
floop   move.w  0(a4,d5.w),d4           ;Shape zeichnen
        lsl.w   #5,d4                   ;neue Linie zeichnen
        move.l  8(a5,d4.w),d0           ;x0
        lsr.l   #8,d0
        move.l  12(a5,d4.w),d1          ;y0
        lsr.l   #8,d1
        move.w  2(a4,d5.w),d4
        lsl.w   #5,d4
        move.l  8(a5,d4.w),d2           ;x1
        lsr.l   #8,d2
        move.l  12(a5,d4.w),d3          ;y1
        lsr.l   #8,d3
        movem.l d5-d7,-(a7)
        move.w  4(a4,d5.w),d6           ;Farbe
        andi.w  #7,d6
        lsl.w   #1,d6
        move.w  0(a1,d6.w),d6
        jsr     line
        movem.l (a7)+,d5-d7
        move.w  0(a4,d5.w),d4           ;alte Linie loeschen
        lsl.w   #5,d4
        move.l  0(a5,d4.w),d0
        lsr.l   #8,d0
        move.l  4(a5,d4.w),d1
        lsr.l   #8,d1
        move.w  2(a4,d5.w),d4
        lsl.w   #5,d4
        move.l  0(a5,d4.w),d2
        lsr.l   #8,d2
        move.l  4(a5,d4.w),d3
        lsr.l   #8,d3
        movem.l d5-d7,-(a7)
        move.w  4(a4,d5.w),d6
        andi.w  #7,d6
        lsl.w   #1,d6
        move.w  0(a1,d6.w),d6
        jsr     line
        movem.l (a7)+,d5-d7
        addq.l  #6,d5
        dbra    d6,floop
        rts
    
loesch  moveq   #0,d5
flloop  move.w  0(a4,d5.w),d4
        lsl.w   #5,d4
        move.l  8(a5,d4.w),d0
        lsr.l   #8,d0
        move.l  12(a5,d4.w),d1
        lsr.l   #8,d1
        move.w  2(a4,d5.w),d4
        lsl.w   #5,d4
        move.l  8(a5,d4.w),d2
        lsr.l   #8,d2
        move.l  12(a5,d4.w),d3
        lsr.l   #8,d3
        movem.l d5-d7,-(a7)
        move.w  4(a4,d5.w),d6
        andi.w  #7,d6
        lsl.w   #1,d6
        move.w  0(a1,d6.w),d6
        jsr     line
        movem.l (a7)+,d5-d7
        addq.l  #6,d5
        dbra    d6,flloop
        rts

line    move.w  d6,-(a7)
        cmp.w   d0,d2
        bge.s   weiter1
        exg     d0,d2
        exg     d1,d3
weiter1 move.w  xmin,d4
        move.w  xmax,d5
        move.w  ymin,d6
        move.w  ymax,d7
        cmp.w   d4,d0                 ;x1<xmin
        bpl     c1                      ;nein
        cmp.w   d4,d2                 ;x2<xmin
        bmi     eline
        movem.l d2-d3,-(a7)
        sub.w   d0,d2                   ;delta x
        sub.w   d1,d3                   ;delta y
        sub.w   d4,d0                 ;x1-xmin
        ext.l   d3
        lsl.l   #8,d3                   ;256*delta y
        divs    d2,d3                   ;256*delta y / delta x
        muls    d0,d3                   ;x1*256*delta y / delta x
        lsr.l   #8,d3                   ;x1*delta y / delta x
        sub.w   d3,d1                   ;y1-x1*delta y / delta x
        move.w  d4,d0                 ;x1=xmin
        movem.l (a7)+,d2-d3
c1      cmp.w   d5,d0                 ;x1>xmax
        bpl     eline                     ;ja
        cmp.w   d5,d2                 ;x2>xmax
        bmi     c2                      ;nein
        movem.l d0-d1,-(a7)
        neg.w   d0
        neg.w   d1
        add.w   d2,d0                   ;delta x
        add.w   d3,d1                   ;delta y
        ext.l   d1
        lsl.l   #8,d1                   ;256*delta y
        sub.w   d5,d2                 ;xmax-x2
        neg.w   d2
        divs    d0,d1                   ;256*delta y / delta x
        muls    d2,d1                   ;( 400 - x2 )*256*delta y / delta x
        lsr.l   #8,d1                   ;( 400 - x2 )*delta y /delta x
        add.w   d1,d3                   ;y1+(400-x2)*delta y / delta x
        move.w  d5,d2                 ;x2=xmax
        movem.l (a7)+,d0-d1
c2      cmp.w   d6,d1                 ;y1<ymin
        bpl     c3                      ;nein
        cmp.w   d6,d3                 ;y2<ymin
        bmi     eline                     ;ja
        movem.l d2-d3,-(a7)
        sub.w   d0,d2                   ;delta x
        sub.w   d1,d3                   ;delta y
        ext.l   d2
        sub.w   d6,d1                 ;y1-ymin
        lsl.l   #8,d2                   ;256*delta x
        divs    d3,d2                   ;256*delta x / delta y
        muls    d1,d2                   ;y1*256*delta x / delta y
        lsr.l   #8,d2                   ;y1*delta x / delta y
        sub.w   d2,d0                   ;x0-y1*delta x / delta y
        move.w  d6,d1                 ;y1=ymin
        movem.l (a7)+,d2-d3
c3      cmp.w   d7,d1                 ;y1>ymax
        bmi     c4                      ;nein
        cmp.w   d7,d3                 ;y2>ymax
        bpl     eline                     ;ja
        movem.l d2-d3,-(a7)
        sub.w   d0,d2                   ;delta x
        sub.w   d1,d3                   ;delta y
        ext.l   d2
        lsl.l   #8,d2                   ;256*delta x
        sub.w   d7,d1                 ;ymax-y1
        neg.w   d1
        divs    d3,d2                   ;256*delta x / delta y
        muls    d1,d2                   ;(200-y1)*256*delta x / delta y
        lsr.l   #8,d2                   ;(200-y1)*delta x / delta y
        add.w   d2,d0                   ;x0+(200-y1)*delta x / delta y
        move.w  d7,d1                 ;y1=ymax
        movem.l (a7)+,d2-d3
c4      cmp.w   d6,d3
        bpl     c5
        movem.l d0-d1,-(a7)     
        neg.w   d0
        neg.w   d1
        add.w   d2,d0                   ;delta x
        add.w   d3,d1                   ;delta y
        ext.l   d0
        sub.w   d6,d3                 ;y2-ymin
        lsl.l   #8,d0                   ;256*delta x
        divs    d1,d0                   ;256*delta x / delta y
        muls    d3,d0                   ;y2*256*delta x / delta y
        lsr.l   #8,d0                   ;y2*delta x / delta y
        sub.w   d0,d2                   ;x2-y2*delta x / delta y
        move.w  d6,d3                 ;y2=ymin
        movem.l (a7)+,d0-d1
c5      cmp.w   d7,d3                 ;y2>ymax
        bmi     c6                      ;nein
        movem.l d0-d1,-(a7)
        neg.w   d0
        neg.w   d1
        add.w   d2,d0                   ;delta x
        add.w   d3,d1                   ;delta y
        ext.l   d0
        lsl.l   #8,d0                   ;256*delta x
        sub.w   d7,d3                 ;y2-ymax
        neg.w   d3
        divs    d1,d0                   ;256*delta x / delta y
        muls    d3,d0                   ;(200-y2)*256*delta x / delta y
        lsr.l   #8,d0                   ;(200-y2)*delta x / delta y
        add.w   d0,d2                   ;x2+(200-y2)*delta x / delta y
        move.w  d7,d3                 ;y1=ymax
        movem.l (a7)+,d0-d1
c6      move.w  (a7),d6

;extrem schnelle line-routine bitte beachten
;falls schnellere bekannt bitte melden
;d0 = x-koordinate punkt 1
;d1 = y-koordinate punkt 1
;d2 = x-koordinate punkt 2
;d3 = y-koordiante punkt 2
        lea     $20000,a0       ;start bildspeicher
        sub.w   d0,d2           ;delta x
        move.w  d0,d5           ;x nach d5
        lsr.w   #3,d0           ;8 bitspalten pro wortspalte
        lsl.w   #1,d0           ;nur gerade adressen
        add.w   d0,a0           ;startadresse der spalte
        moveq   #-128,d4        ;negative steigung
        sub.w   d1,d3           ;delta y
        beq     hl1             ;delta y = 0 horizontale linie
        bpl.s   mst2            ;positive steigung
        neg.w   d3              ;delta y = -delta y
        bra.s   mst2a
mst2    neg.w   d4              ;positive steigung
mst2a   moveq   #-128,d0        ;bitmaske fuer farbe weiss
        ror.w   d5,d6           ;farbmaske
        ror.b   d5,d0           ;bitmaske fuer linienanfang
        lsl.w   #7,d1           ;startzeile * 128
        add.w   d1,a0           ;startadresse fuer zeile
        tst.w   d2              ;delta x = 0 ?
        beq     vl1             ;ja vertikale linie
        cmp.w   d2,d3           ; x- oder y-richtung
        beq.s   dline           ;diagonale
        bgt.s   yl              ;y-richtung
;x-richtung
        move.w  d2,d7
        neg.w   d7              ;flag vorbereiten
        move.w  d2,d5
        subq.w  #1,d5           ;punktzaehler
        move.w  d6,d1           ;bitmaske
        bra.s   @2
@1      add.w   d3,d7           ;flag testen
        bpl.s   @4
        or.w    d6,d1           ;punktmaske
@2      ror.w   #1,d6           ;farbmaske
        ror.b   #1,d0           ;naechste spalte
        bcs.s   @3              ;naechste wortspalte
        dbra    d5,@1
        eor.w   d1,(a0)         ;punkte setzen
        move.w  (a7)+,d6
        rts
@3      rol.w   #8,d6           ;farbmaske in ordnung bringen
        eor.w   d1,(a0)+        ;punkte setzen
        moveq   #0,d1
        dbra    d5,@1
        move.w  (a7)+,d6
        rts
@4      eor.w   d1,(a0)         ;punkte setzen
        move.w  d6,d1           ;bitmaske
        add.w   d4,a0           ;naechste zeile
        sub.w   d2,d7           ;flag
        bra.s   @2
;diagonale
dline   eor.w   d6,(a0)         ;punkt setzen
        add.w   d4,a0           ;naechste zeile
        ror.w   #1,d6           ;farbmaske 
        ror.b   #1,d0           ;naechste punktspalte
        bcs.s   @1              ;naechste wortspalte
        dbra    d2,dline
        move.w  (a7)+,d6
        rts
@1      rol.w   #8,d6           ;farbmaske in ordnung bringen
        addq.w  #2,a0           ;naechste wortspalte
        dbra    d2,dline
        move.w  (a7)+,d6
        rts  
;y-richtung
yl      move.w  d3,d7           ;flag vorbereiten
        move.w  d3,d5
        subq.w  #1,d5           ;punktzaehler
        bra.s   @2
@1      sub.w   d2,d7           ;flag testen
        bmi.s   @3
@2      eor.w   d6,(a0)         ;punkt setzen
        add.w   d4,a0           ;naechste zeile
        dbra    d5,@1
        move.w  (a7)+,d6
        rts
@3      add.w   d3,d7           ;flag
        ror.w   #1,d6           ;farbmaske
        ror.b   #1,d0           ;naechste bitspalte
        bcc.s   @2
        rol.w   #8,d6           ;farbmaske in ordnung bringen
        addq.w  #2,a0           ;naechste wortspalte
        bra.s   @2

;routine fuer horizontale linien
hl1     subq.w  #1,d2           ;korrektur fuer dbra
        bmi.s   eline           ;keine punkte mehr
        move.w  #$8080,d0       ;bitmaske
        ror.w   d5,d6           ;farbmaske
        ror.b   d5,d0           ;bitmaske fuer spalte
        lsl.w   #7,d1           ;startzeile * 128
        add.w   d1,a0           ;startadresse fuer zeile
        cmp.b   #-128,d0        ;wortgrenze
        beq.s   hl2             ;special
        moveq   #0,d1           ;bitmaske loeschen
hl1l    or.w    d6,d1           ;bitmaske aktualisieren
hl1l1   ror.w   #1,d6           ;farbmaske
        ror.b   #1,d0           ;bitmaske fuer spalte
        bcs.s   @1              ;noch gleiche wortspalte
        dbra    d2,hl1l         ;naechster punkt
        eor.w   d1,(a0)         ;punkte setzen
        move.w  (a7)+,d6
        rts
@1      eor.w   d1,(a0)+        ;punkte setzen
hl2     move.w  (a7),d6         ;farbwort generieren
        move.w  d6,d1
        ror.w   #1,d6
        or.w    d6,d1
        ror.w   #1,d6
        or.w    d6,d1
        ror.w   #1,d6
        or.w    d6,d1
        ror.w   #1,d6
        or.w    d6,d1
        ror.w   #1,d6
        or.w    d6,d1
        ror.w   #1,d6
        or.w    d6,d1
        ror.w   #1,d6
        or.w    d6,d1
@1      subq.w  #8,d2           ;keine wortgrenze mehr
        bmi.s   @2
        eor.w   d1,(a0)+        ;punkte
        bra.s   @1
@2      cmp.w   #-8,d2          ;wortgrenze
        beq.s   eline
        moveq   #7,d6
        addq.w  #8,d2           ;letzten reset
        sub.w   d2,d6
        ror.w   #8,d1
        lsl.b   d6,d1
        eor.b   d1,(a0)+
        ror.w   #8,d1
        lsl.b   d6,d1
        eor.b   d1,(a0)
        move.w  (a7)+,d6
        rts
        
;routine fuer vertikale linien
vl1     subq.w  #1,d3           ;korrektur fuer dbra
        bmi.s   eline           ;keine punkte
vl1l    eor.w   d6,(a0)         ;punkt setzen
        add.w   d4,a0           ;naechste zeile
        dbra    d3,vl1l         ;naechster punkt
eline   move.w  (a7)+,d6
        rts

punkt   move.w  d0,d2
        andi.w  #$fe00,d2
        bne.s   ende
        move.w  d1,d2
        andi.w  #$ff00,d2
        bne.s   ende
        lea     $20000,a0
        lsl.w   #7,d1
        add.w   d1,a0
        move.w  d0,d5
        lsr.w   #2,d5
        bclr    #0,d5
        add.w   d5,a0
        andi.w  #7,d0
        ror.w   d0,d6
        eor.w   d6,(a0)
ende    rts

sin      DC.W    $0000,$4000,$011D,$3FFD,$023B,$3FF6,$0359,$3FE9
         DC.W    $0476,$3FD8,$0593,$3FC1,$06B0,$3FA6,$07CC,$3F85
         DC.W    $08E8,$3F60,$0A03,$3F36,$0B1D,$3F07,$0C36,$3ED2
         DC.W    $0D4E,$3E99,$0E65,$3E5C,$0F7B,$3E19,$1090,$3DD1
         DC.W    $11A4,$3D85,$12B6,$3D34,$13C6,$3CDE,$14D6,$3C83
         DC.W    $15E3,$3C23,$16EF,$3BBF,$17F9,$3B56,$1901,$3AE9
         DC.W    $1A07,$3A77,$1B0C,$3A00,$1C0E,$3985,$1D0E,$3906
         DC.W    $1E0B,$3882,$1F07,$37F9,$2000,$376C,$20F6,$36DB
         DC.W    $21EA,$3646,$22DB,$35AC,$23C9,$350E,$24B5,$346C
         DC.W    $259E,$33C6,$2684,$331C,$2766,$326E,$2846,$31BC
         DC.W    $2923,$3106,$29FC,$304D,$2AD3,$2F8F,$2BA5,$2ECE
         DC.W    $2C75,$2E09,$2D41,$2D41,$2E09,$2C75,$2ECE,$2BA5
         DC.W    $2F8F,$2AD3,$304D,$29FC,$3106,$2923,$31BC,$2846
         DC.W    $326E,$2766,$331C,$2684,$33C6,$259E,$346C,$24B5
         DC.W    $350E,$23C9,$35AC,$22DB,$3646,$21EA,$36DB,$20F6
         DC.W    $376C,$2000,$37F9,$1F07,$3882,$1E0B,$3906,$1D0E
         DC.W    $3985,$1C0E,$3A00,$1B0C,$3A77,$1A07,$3AE9,$1901
         DC.W    $3B56,$17F9,$3BBF,$16EF,$3C23,$15E3,$3C83,$14D6
         DC.W    $3CDE,$13C6,$3D34,$12B6,$3D85,$11A4,$3DD1,$1090
         DC.W    $3E19,$0F7B,$3E5C,$0E65,$3E99,$0D4E,$3ED2,$0C36
         DC.W    $3F07,$0B1D,$3F36,$0A03,$3F60,$08E8,$3F85,$07CC
         DC.W    $3FA6,$06B0,$3FC1,$0593,$3FD8,$0476,$3FE9,$0359
         DC.W    $3FF6,$023B,$3FFD,$011D,$4000,$0000,$3FFD,$FEE2
         DC.W    $3FF6,$FDC4,$3FE9,$FCA6,$3FD8,$FB89,$3FC1,$FA6C
         DC.W    $3FA6,$F94F,$3F85,$F833,$3F60,$F717,$3F36,$F5FC
         DC.W    $3F07,$F4E2,$3ED2,$F3C9,$3E99,$F2B1,$3E5C,$F19A
         DC.W    $3E19,$F084,$3DD1,$EF6F,$3D85,$EE5B,$3D34,$ED49
         DC.W    $3CDE,$EC39,$3C83,$EB29,$3C23,$EA1C,$3BBF,$E910
         DC.W    $3B56,$E806,$3AE9,$E6FE,$3A77,$E5F8,$3A00,$E4F3
         DC.W    $3985,$E3F1,$3906,$E2F1,$3882,$E1F4,$37F9,$E0F8
         DC.W    $376C,$E000,$36DB,$DF09,$3646,$DE15,$35AC,$DD24
         DC.W    $350E,$DC36,$346C,$DB4A,$33C6,$DA61,$331C,$D97B
         DC.W    $326E,$D899,$31BC,$D7B9,$3106,$D6DC,$304D,$D603
         DC.W    $2F8F,$D52C,$2ECE,$D45A,$2E09,$D38A,$2D41,$D2BE
         DC.W    $2C75,$D1F6,$2BA5,$D131,$2AD3,$D070,$29FC,$CFB2
         DC.W    $2923,$CEF9,$2846,$CE43,$2766,$CD91,$2684,$CCE3
         DC.W    $259E,$CC39,$24B5,$CB93,$23C9,$CAF1,$22DB,$CA53
         DC.W    $21EA,$C9B9,$20F6,$C924,$2000,$C893,$1F07,$C806
         DC.W    $1E0B,$C77D,$1D0E,$C6F9,$1C0E,$C67A,$1B0C,$C5FF
         DC.W    $1A07,$C588,$1901,$C516,$17F9,$C4A9,$16EF,$C440
         DC.W    $15E3,$C3DC,$14D6,$C37C,$13C6,$C321,$12B6,$C2CB
         DC.W    $11A4,$C27A,$1090,$C22E,$0F7B,$C1E6,$0E65,$C1A3
         DC.W    $0D4E,$C166,$0C36,$C12D,$0B1D,$C0F8,$0A03,$C0C9
         DC.W    $08E8,$C09F,$07CC,$C07A,$06B0,$C059,$0593,$C03E
         DC.W    $0476,$C027,$0359,$C016,$023B,$C009,$011D,$C002
         DC.W    $0000,$C000,$FEE2,$C002,$FDC4,$C009,$FCA6,$C016
         DC.W    $FB89,$C027,$FA6C,$C03E,$F94F,$C059,$F833,$C07A
         DC.W    $F717,$C09F,$F5FC,$C0C9,$F4E2,$C0F8,$F3C9,$C12D
         DC.W    $F2B1,$C166,$F19A,$C1A3,$F084,$C1E6,$EF6F,$C22E
         DC.W    $EE5B,$C27A,$ED49,$C2CB,$EC39,$C321,$EB29,$C37C
         DC.W    $EA1C,$C3DC,$E910,$C440,$E806,$C4A9,$E6FE,$C516
         DC.W    $E5F8,$C588,$E4F3,$C5FF,$E3F1,$C67A,$E2F1,$C6F9
         DC.W    $E1F4,$C77D,$E0F8,$C806,$E000,$C893,$DF09,$C924
         DC.W    $DE15,$C9B9,$DD24,$CA53,$DC36,$CAF1,$DB4A,$CB93
         DC.W    $DA61,$CC39,$D97B,$CCE3,$D899,$CD91,$D7B9,$CE43
         DC.W    $D6DC,$CEF9,$D603,$CFB2,$D52C,$D070,$D45A,$D131
         DC.W    $D38A,$D1F6,$D2BE,$D2BE,$D1F6,$D38A,$D131,$D45A
         DC.W    $D070,$D52C,$CFB2,$D603,$CEF9,$D6DC,$CE43,$D7B9
         DC.W    $CD91,$D899,$CCE3,$D97B,$CC39,$DA61,$CB93,$DB4A
         DC.W    $CAF1,$DC36,$CA53,$DD24,$C9B9,$DE15,$C924,$DF09
         DC.W    $C893,$DFFF,$C806,$E0F8,$C77D,$E1F4,$C6F9,$E2F1
         DC.W    $C67A,$E3F1,$C5FF,$E4F3,$C588,$E5F8,$C516,$E6FE
         DC.W    $C4A9,$E806,$C440,$E910,$C3DC,$EA1C,$C37C,$EB29
         DC.W    $C321,$EC39,$C2CB,$ED49,$C27A,$EE5B,$C22E,$EF6F
         DC.W    $C1E6,$F084,$C1A3,$F19A,$C166,$F2B1,$C12D,$F3C9
         DC.W    $C0F8,$F4E2,$C0C9,$F5FC,$C09F,$F717,$C07A,$F833
         DC.W    $C059,$F94F,$C03E,$FA6C,$C027,$FB89,$C016,$FCA6
         DC.W    $C009,$FDC4,$C002,$FEE2,$C000,$FFFF,$C002,$011D
         DC.W    $C009,$023B,$C016,$0359,$C027,$0476,$C03E,$0593
         DC.W    $C059,$06B0,$C07A,$07CC,$C09F,$08E8,$C0C9,$0A03
         DC.W    $C0F8,$0B1D,$C12D,$0C36,$C166,$0D4E,$C1A3,$0E65
         DC.W    $C1E6,$0F7B,$C22E,$1090,$C27A,$11A4,$C2CB,$12B6
         DC.W    $C321,$13C6,$C37C,$14D6,$C3DC,$15E3,$C440,$16EF
         DC.W    $C4A9,$17F9,$C516,$1901,$C588,$1A07,$C5FF,$1B0C
         DC.W    $C67A,$1C0E,$C6F9,$1D0E,$C77D,$1E0B,$C806,$1F07
         DC.W    $C893,$1FFF,$C924,$20F6,$C9B9,$21EA,$CA53,$22DB
         DC.W    $CAF1,$23C9,$CB93,$24B5,$CC39,$259E,$CCE3,$2684
         DC.W    $CD91,$2766,$CE43,$2846,$CEF9,$2923,$CFB2,$29FC
         DC.W    $D070,$2AD3,$D131,$2BA5,$D1F6,$2C75,$D2BE,$2D41
         DC.W    $D38A,$2E09,$D45A,$2ECE,$D52C,$2F8F,$D603,$304D
         DC.W    $D6DC,$3106,$D7B9,$31BC,$D899,$326E,$D97B,$331C
         DC.W    $DA61,$33C6,$DB4A,$346C,$DC36,$350E,$DD24,$35AC
         DC.W    $DE15,$3646,$DF09,$36DB,$DFFF,$376C,$E0F8,$37F9
         DC.W    $E1F4,$3882,$E2F1,$3906,$E3F1,$3985,$E4F3,$3A00
         DC.W    $E5F8,$3A77,$E6FE,$3AE9,$E806,$3B56,$E910,$3BBF
         DC.W    $EA1C,$3C23,$EB29,$3C83,$EC39,$3CDE,$ED49,$3D34
         DC.W    $EE5B,$3D85,$EF6F,$3DD1,$F084,$3E19,$F19A,$3E5C
         DC.W    $F2B1,$3E99,$F3C9,$3ED2,$F4E2,$3F07,$F5FC,$3F36
         DC.W    $F717,$3F60,$F833,$3F85,$F94F,$3FA6,$FA6C,$3FC1
         DC.W    $FB89,$3FD8,$FCA6,$3FE9,$FDC4,$3FF6,$FEE2,$3FFD

xmin    DC.W    $0000
xmax    DC.W    $01FF
ymin    DC.W    $0000
ymax    DC.W    $00FF

farbe   DC.W    $0000,$0000,$0080,$0080,$8000,$8000,$8080,$8080

platz   ds.b    2
