;                   TRINT  : fonction SUPERBASIC renvoyant la partie
;                            entire tronque d'un nombre  virgule
;                            flottante
;                   PROUND : fonction SUPERBASIC renvoyant l'arrondi du
;                            nombre  virgule flottante spcifi en 2me
;                            paramtre  la puissance de 10 spcifie en
;                            1er paramtre
;                   DROUND : fonction SUPERBASIC renvoyant l'arrondi du
;                            nombre  virgule flottante spcifi en 2me
;                            paramtre au nombre de chiffres significatifs
;                            spcifi en 1er paramtre

;                   utilisation : partie_entire    = TRINT (nombre)
;                                 arrondi_puissance = PROUND(-2,1.234)
;                                 arrondi_nchiffres = DROUND( 3,1.234)


bv_rip              equ       $58
ri_nint             equ       $02
ri_int              equ       $04
ri_float            equ       $08
ri_add              equ       $0a
ri_sub              equ       $0c
ri_mult             equ       $0e
ri_div              equ       $10
ri_abs              equ       $12
ri_neg              equ       $14
ri_dup              equ       $16
ri_log10            equ       $2c
ri_powfp            equ       $30


                    move.w    bp_init,a0
                    lea       TABLE,a1
                    jsr       (a0)
                    rts

TRINT               move.w    ca_gtfp,a0
                    jsr       (a0)
                    bne.s     ERREUR_BP
                    sub.w     #1,d3               La fonction n'accepte
                    bne.s     ERREUR_BP           qu'un paramtre

NOYAU_TRINT         move.b    2(a6,a1.l),d7       Sauve et teste le signe
                    bpl.s     POSNUL1

                    move.w    ri_exec,a0          Opration arithmtique

                    moveq     #ri_neg,d0          Inverse le signe
                    jsr       (a0)

POSNUL1             move.w    0(a6,a1.l),d1       d1 = exposant
                    move.l    2(a6,a1.l),d2       d2 = mantisse
                    sub.w     #$81f,d1
                    bge.s     TEST_INVERSION      Pas de partie fract.

                    neg.w     d1
                    cmp.w     #32,d1
                    ble.s     DANS_LA_LIMITE
                    moveq     #32,d1              32 dcalages maximum

DANS_LA_LIMITE      lsr.l     d1,d2               Calcule la mantisse
                    lsl.l     d1,d2

                    move.l    d2,2(a6,a1.l)       Place la mantisse

TEST_INVERSION      tst.b     d7
                    bpl.s     SORTIE

                    moveq     #ri_neg,d0          Inverse le signe
                    jsr       (a0)

SORTIE              moveq     #2,d4               Type = flottant
                    rts
ERREUR_BP           moveq     #err_bp,d0
ERREUR1             rts

PROUND              bsr.s     SAISIE_PARAMETRES
                    bne.s     ERREUR1

                    moveq     #ri_neg,d0          Inverse le signe de la
                    jsr       (a0)                puissance

NOYAU_PROUND        moveq     #ri_dup,d0          Duplique la puissance
                    jsr       (a0)

                    move.w    #$0804,6(a6,a1.l)             Valeur 10 en
                    move.l    #$50000000,8(a6,a1.l)         flottant

                    moveq     #ri_powfp,d0        Elve 10  la puissance
                    jsr       (a0)                spcifie en 1er param.
                    bne.s     ERREUR1

                    move.w    0(a6,a1.l),d5       Sauve la valeur
                    move.l    2(a6,a1.l),d6

                    moveq     #ri_mult,d0
                    jsr       (a0)
                    bne.s     ERREUR1

                    sub.l     #6,a1
                    move.w    #$0800,0(a6,a1.l)             Valeur .5 en
                    move.l    #$40000000,2(a6,a1.l)         flottant

                    tst.b     8(a6,a1.l)          Si nombre
                    bpl.s     POSNUL2             ngatif...

                    moveq     #ri_neg,d0          ...valeur -.5
                    jsr       (a0)

POSNUL2             moveq     #ri_add,d0
                    jsr       (a0)
                    bne.s     ERREUR1

                    bsr       NOYAU_TRINT

                    sub.l     #6,a1               Rcupre la valeur
                    move.w    d5,0(a6,a1.l)       pralablement sauve
                    move.l    d6,2(a6,a1.l)

                    moveq     #ri_div,d0
                    jsr       (a0)
                    bne.s     ERREUR1

                    move.l    a1,bv_rip(a6)       Rservation pour retour
                    bra.s     SORTIE

SAISIE_PARAMETRES   move.w    ca_gtfp,a0          La fonction n'accepte
                    jsr       (a0)                que deux paramtres
                    bne.s     ERREUR2
                    moveq     #err_bp,d0
                    sub.w     #2,d3
                    bne.s     ERREUR2

                    moveq     #6,d1               Rserve 6 octets sur la
                    move.w    bv_chrix,a0         pile arithmtique
                    jsr       (a0)
                    move.l    bv_rip(a6),a1

                    move.w    ri_exec,a0

                    moveq     #ri_nint,d0         Le 1er paramtre doit
                    jsr       (a0)                tre un entier...
                    bne.s     ERREUR2

                    moveq     #ri_float,d0        ...recod en flottant
                    jsr       (a0)                pour la suite

ERREUR2             rts

DROUND              bsr.s     SAISIE_PARAMETRES
                    bne.s     ERREUR2

                    tst.b     2(a6,a1.l)          Le 1er paramtre ne peut
                    ble       ERREUR_BP           tre ni nul, ni ngatif

                    tst.l     8(a6,a1.l)          Cas particulier : 0
                    beq       NOYAU_PROUND

                    sub.l     #6,a1                         Transfre le
                    move.w    12(a6,a1.l),0(a6,a1.l)        nombre
                    move.l    14(a6,a1.l),2(a6,a1.l)

                    moveq     #ri_abs,d0          Ncessaire pour le
                    jsr       (a0)                calcul suivant

                    moveq     #ri_log10,d0        Permet...
                    jsr       (a0)
                    bne.s     ERREUR2

                    moveq     #ri_int,d0          ...de calculer...
                    jsr       (a0)
                    bne.s     ERREUR2

                    add.w     #1,0(a6,a1.l)       ...le nombre...

                    moveq     #ri_float,d0        ...de chiffres...
                    jsr       (a0)

                    moveq     #ri_sub,d0          ...prsents devant la
                    jsr       (a0)                virgule et d'en dduire
                    bne.s     ERREUR2             la puissance de 10...

                    bra       NOYAU_PROUND        ...adquate

TABLE               dc.w      0,0,3
                    dc.w      TRINT-*
                    dc.b      5,"TRINT"
                    dc.w      PROUND-*
                    dc.b      6,"PROUND"
                    dc.w      DROUND-*
                    dc.b      6,"DROUND"
                    dc.w      0

                    END
