20010 REMark ****************************
20020 REMark *  TURBO TOOLKIT EXAMPLES  *
20025 REMark *  V 2.06                  *
20030 REMark ****************************
20040 :
20050 REMark This file contains lots of useful program subroutines. Most
20060 REMark of these rely upon TURBO TOOLKIT commands, so they serve as
20070 REMark examples of the toolkit in use; a few use normal QL BASIC
20080 REMark commands to do unexpected or useful things, adding to the
20090 REMark the utility and effectiveness of the Toolkit. The routines
20100 REMark are provided in SOURCE - not code - form for three reasons:
20110 REMark 
20120 REMark (1) You can thus examine, modify and expand them easily;
20130 REMark (2) You only have to load routines that you NEED NOW;
20140 REMark (3) Machine-code would not be much faster - the demos can be
20150 REMark     compiled, and use resident m/code where speed is vital.
20160 :
20170 REMark The best way to use these routines is to edit them as needed
20180 REMark from the file, using the LIBRARY MANAGER or THE EDITOR. Save
20190 REMark the 'edited highlights' and MERGE them with your own code.
20200 REMark There are no GOTOs or GOSUBs here, but you should watch out
20210 REMark for RESTOREs when moving code around.
20220 :
20230 REMark WARNING: Some routines call others in this file; such names
20240 REMark appear in Mixed_CASE; remember to include called routines in
20250 REMark the file you save. All calls are listed in the manual.
20260 :
20270 DEFine PROCedure Find(name$)
20280   LOCal pos%,details
20290   pos%=BASIC_INDEX%(name$)
20300   IF pos%<0 : PRINT #0;"Entry ";name$;" is missing.":RETurn 
20310   details=pos%*8+BASIC_L(24)
20320   IF BASIC_B%(details)<4 OR BASIC_B%(details)>5 : PRINT #0;name$;" is not a Basic definition!":RETurn 
20330   CLS #2:LIST BASIC_W%(details+4)
20340 END DEFine Find
20350 :
20360 DEFine FuNction Slave_SPACE
20370   RETurn PEEK_L(SYS_VARS+16)-PEEK_L(SYS_VARS+12)
20380 END DEFine Slave_SPACE
20390 :
20400 DEFine PROCedure How_COME
20410   LOCal I
20420   CLS 2:PRINT
20430   I=BASIC_L(56)
20440   REPeat scan_rt
20450     I=I+24
20460     IF I>BASIC_L(60)-24 : EXIT scan_rt
20470     IF BASIC_W%(I+18)
20480       PRINT "Call at ";BASIC_W%(I+18);" in ";
20490     ELSE 
20500       PRINT "Stop at ";BASIC_W%(146);" in ";
20510     END IF 
20520     IF BASIC_W%(I-12)>0 : LIST #1;BASIC_W%(I-12)
20530   END REPeat scan_rt
20540 END DEFine How_COME
20550 :
20560 DEFine FuNction Buffer_SIZE
20570   RETurn BASIC_L(8)-BASIC_L(0)
20580 END DEFine Buffer_SIZE
20590 :
20600 DEFine FuNction Prog_SIZE
20610   RETurn BASIC_L(40)-BASIC_L(16)
20620 END DEFine Prog_SIZE
20630 :
20640 DEFine FuNction Variable_SIZE
20650   RETurn BASIC_L(48)-BASIC_L(40)
20660 END DEFine Variable_SIZE
20670 :
20680 DEFine FuNction Basic_SIZE
20690   RETurn PEEK_L(SYS_VARS+20)-PEEK_L(SYS_VARS+16)
20700 END DEFine Basic_SIZE
20710 :
20720 DEFine PROCedure Turbo_CLOCK
20730   SET_PRIORITY 1:REPeat tick:AT 0,0:PRINT DATE$;
20740 END DEFine Turbo_CLOCK
20750 :
20760 DEFine PROCedure Spool
20770   LOCal in$(40),out$(40)
20780   REPeat spooler
20790     REPeat get_in:INPUT "Input file ";in$:IF Read_OK(in$) : EXIT get_in
20800     REPeat get_out
20810       INPUT "Output file ";out$
20820       IF Write_OK(out$,File_SIZE(in$))=0 : EXIT get_out
20830     END REPeat get_out
20840     COPY in$ TO out$
20850     PRINT in$;" copied to ";out$;". More";
20860     IF Yea_Or_NAY=0 : EXIT spooler
20870   END REPeat spooler
20880 END DEFine Spool
20890 :
20900 DEFine FuNction Yea_Or_NAY
20910   LOCal key$(1)
20920   PRINT " (Y/N) ? ";:CURSOR_ON
20930   REPeat poll
20940     key$=INKEY$(#1,-1):IF key$=="y" OR key$=="n"
20950       PRINT key$:CURSOR_OFF
20960       RETurn key$=="y"
20970     END IF 
20980   END REPeat poll
20990 END DEFine Yea_Or_NAY
21000 :
21010 DEFine FuNction Read_OK(name$)
21020   RETurn DEVICE_STATUS(1,name$)>=0
21030 END DEFine Read_OK
21040 :
21050 DEFine FuNction Write_OK(name$,size)
21060   LOCal status
21070   REPeat try_write
21080     status=DEVICE_STATUS(-1,name$)
21090     IF status=-8
21100       PRINT "Delete ";name$;
21110       IF Yea_Or_NAY : DELETE name$ :ELSE status=0
21120     ELSE 
21130       EXIT try_write
21140     END IF 
21150   END REPeat try_write
21160   IF status>=size
21170     status=1
21180   ELSE 
21190     IF status>0 : status=-11:REMark DRIVE FULL (no room)
21200   END IF 
21210   RETurn status
21220 END DEFine Write_OK
21230 :
21240 DEFine PROCedure Flip1
21250   LOCal screen$(128)
21260   FOR I=0 TO 32640 STEP 128
21270     screen$=PEEK$(131072+I,128)
21280     MOVE_MEMORY 128,163712-I TO 131072+I
21290     POKE$ 163712-I,screen$
21300   END FOR I
21310 END DEFine Flip1
21320 :
21330 DEFine PROCedure Flip2
21340   LOCal I,lin
21350   lin=ALLOCATION(128)
21360   IF lin<0 : PRINT #0;"Out of memory":RETurn 
21370   FOR I=0 TO 32640 STEP 128
21380     MOVE_MEMORY 131072+I TO lin,128
21390     MOVE_MEMORY 128,163712-I TO 131072+I
21400     MOVE_MEMORY lin TO 163712-I,128
21410   END FOR I
21420   DEALLOCATE lin
21430 END DEFine Flip2
21440 :
21450 DEFine PROCedure Stretch
21460   LOCal I
21470   FOR I=16256 TO 0 STEP -128
21480     MOVE_MEMORY 131072+I TO 131072+I+I,128
21490     MOVE_MEMORY 131072+I TO 131072+I+I+128,128
21500   END FOR I
21510 END DEFine Stretch
21520 :
21530 DEFine PROCedure Animate
21540   MODE 4:OPEN #3,scr_512x64a0x64
21550   INK #3,4:CSIZE #3,2,1:base=ALLOCATION(65536)
21560   IF base<0:PRINT#0!"**** ANIMATE needs 64K of free RAM.":STOP
21570   FOR I=0 TO 7
21580     CLS #3
21590     FOR x=100 TO 500 STEP 100:FILL #3,1:ELLIPSE #3,x,50,I+I+2,3,I/2:FILL #3,0:CIRCLE #3,x+50,I*14,10
21600     AT #3,0,5:PRINT #3;I;:MOVE_MEMORY 139264 TO base+I*8192,8192
21610   END FOR I
21620   FOR j=0 TO 10
21630     FOR I=7 TO 0 STEP -1:MOVE_MEMORY base+I*8192 TO 139264,8192
21640     FOR I=0 TO 7:MOVE_MEMORY base+I*8192 TO 139264,8192
21650   END FOR j:DEALLOCATE base:CLOSE #3
21660 END DEFine Animate
21670 :
21680 DEFine PROCedure Create_FONT
21690   font_ptr=ALLOCATION(11)
21700   IF font_ptr<0 : PRINT #0\"Out of memory!":STOP
21710   RESTORE 21740:REMark This may need to be RENUMbered
21720   FOR x=font_ptr TO font_ptr+10:READ v:POKE x,v
21730   SET_FONT 0,font_ptr:STOP
21740   DATA 128,0,16,8,16,32,16,8,16,32,16
21750 END DEFine Create_FONT
21760 :
21770 DEFine FuNction File_SIZE(filename$)
21780   LOCal file_len
21790   OPEN_IN #3,filename$
21800   SET_POSITION #3,6E6:REMark Wind up to end of file - FOR FLP
21810   file_len=POSITION(#3):REMark Now where are we?
21820   CLOSE #3:RETurn file_len
21830 END DEFine File_SIZE
21840 :
21850 DEFine PROCedure Fast_COPY
21860   LOCal in$(40),out$(40),file_length,data_length
21870   REPeat spooler
21880     REPeat get_in:INPUT "Input file ";in$:IF Read_OK(in$) : EXIT get_in
21890     file_length=File_SIZE(in$)
21900     REPeat get_out:INPUT "Output file ";out$:IF Write_OK(out$,file_length)=1 : EXIT get_out
21910     buffer=ALLOCATION(file_length):IF buffer<0 : PRINT "Too big.":NEXT spooler
21920     LBYTES (in$),buffer:data_length=Task_TYPE(in$)
21930     IF data_length>=0
21940       SEXEC (out$),buffer,file_length,data_length
21950     ELSE 
21960       SBYTES (out$),buffer,file_length
21970     END IF 
21980     DEALLOCATE(buffer)
21990     PRINT in$;" copied to ";out$;". More";
22000     IF Yea_Or_NAY=0 : EXIT spooler
22010   END REPeat spooler
22020 END DEFine Fast_COPY
22030 :
22040 DEFine PROCedure Basic_SEARCH
22050   LOCal a$(1),b$(500)
22060   Line_RANGE
22070   INPUT "Enter text to be located? ";text$
22080   OPEN #4,pipe_2048:REMark Adjust if your lines may be longer than this
22090   CONNECT #4 TO #3
22100   FOR I=first_line% TO final_line% STEP interval%
22110     LIST #4,I
22120     a$=INKEY$(#3,1):IF a$<>""
22130       INPUT #3,b$:IF text$ INSTR a$ & b$ : PRINT "Found at line ";I
22140     END IF 
22150   END FOR I
22160   CLOSE #3:CLOSE #4
22170 END DEFine Basic_SEARCH
22180 :
22190 DEFine PROCedure Funct_REMARK
22200   SET_PRIORITY 1:REMark MUST be compiled!
22210   REPeat poll:IF PEEK_W(SYS_VARS+138)=232 : POKE_W SYS_VARS+138,0:TYPE_IN "REMark "
22220 END DEFine Funct_REMARK
22230 :
22240 DEFine PROCedure Unshift
22250   SET_PRIORITY 1:REPeat poll
22260     IF PEEK_W(SYS_VARS+138)=95 : POKE_W SYS_VARS+138,0:TYPE_IN CHR$(194) & "-"
22270     IF PEEK_W(SYS_VARS+138)=45 : POKE_W SYS_VARS+138,0:TYPE_IN CHR$(194) & "_"
22280   END REPeat poll:REMark MUST be compiled
22290 END DEFine Unshift
22300 :
22310 DEFine PROCedure To_UPPER
22320   REMark TURBO compiler pipes needed
22330   IF CHANNEL_ID(#14)<0 OR CHANNEL_ID(#15)<0:PRINT #0,"No pipes!":STOP
22340   REPeat loop
22350     IF EOF(#14) : EXIT loop
22360     k$=INKEY$(#14,-1):k%=CODE(k$)
22370     IF k%>96 AND k%<123 : k$=CHR$(k%-32)
22380     PRINT #15;k$;
22390   END REPeat loop
22400   STOP
22410 END DEFine To_UPPER
22420 :
22430 DEFine FuNction Net_NUMBER%
22440   RETurn PEEK(SYS_VARS+55)
22450 END DEFine Net_NUMBER%
22460 :
22470 DEFine FuNction Task_COUNT%
22480   LOCal I,count%
22490   count%=0
22500   FOR I=PEEK_L(SYS_VARS+104) TO 4*PEEK_W(SYS_VARS+98)+PEEK_L(SYS_VARS+104) STEP 4
22510     IF PEEK_L(I)>0 : count%=count%+1
22520   END FOR I:RETurn count%
22530 END DEFine Task_COUNT%
22540 :
22550 DEFine FuNction Channel_COUNT%
22560   LOCal I,count%
22570   count%=0
22580   FOR I=PEEK_L(SYS_VARS+120) TO 4*PEEK_W(SYS_VARS+114)+PEEK_L(SYS_VARS+120) STEP 4
22590     IF PEEK_L(I)>0 : count%=count%+1
22600   END FOR I:RETurn count%
22610 END DEFine Channel_COUNT%
22620 :
22630 DEFine PROCedure Set_KEYBOARD(x%,y%)
22640   POKE_W SYSBASE+140,x%
22650   IF y%=0 : POKE_W SYS_VARS+142,32767:ELSE POKE_W SYS_VARS+142,50 DIV y%
22660 END DEFine Set_KEYBOARD
22670 :
22680 DEFine FuNction Drive_RUNNING%
22690   RETurn PEEK(SYS_VARS+238)
22700 END DEFine Drive_RUNNING%
22710 :
22720 DEFine PROCedure Caps_LOCK(n)
22730   POKE SYS_VARS+136,255*NOT(NOT(n))
22740 END DEFine Caps_LOCK
22750 :
22760 DEFine FuNction Task_BASE(task_num%)
22770   LOCal task_ptr
22780   IF task_num%=-1 : RETurn PEEK_L(PEEK_L(SYS_VARS+100))
22790   IF task_num%<-1 OR task_num%>PEEK_W(SYS_VARS+98) : PRINT #0,"Invalid task" :STOP
22800   task_ptr=PEEK_L(4*task_num%+PEEK_L(SYS_VARS+104))
22810   IF task_ptr>0 : RETurn task_ptr:ELSE PRINT #0,"Invalid Task":STOP
22820 END DEFine Task_BASE
22830 :
22840 DEFine FuNction Basic_RUNNING
22850   RETurn NOT BASIC_B%(111)
22860 END DEFine Basic_RUNNING
22870 :
22880 REMark For obvious reasons, you will want to compile this routine!
22890 DEFine FuNction Current_LINE%
22900   IF COMPILED : RETurn PEEK_W(58+PEEK_L(PEEK_L(SYS_VARS+100))):ELSE RETurn BASIC_W%(104)
22910 END DEFine Current_LINE%
22920 :
22930 DEFine PROCedure Command_FILE
22940   LOCal in$(40),line$(2048):REMark Alter if necessary
22950   REPeat get_in:INPUT "Input file ";in$:IF Read_OK(in$) : EXIT get_in
22960   OPEN_IN #3,in$:REMark Compile this!
22970   REPeat type_stuff
22980     IF EOF(#3) : EXIT type_stuff
22990     in$=INKEY$(#3,-1):TYPE_IN in$
23000   END REPeat type_stuff
23010   CLOSE #3
23020 END DEFine Command_FILE
23030 :
23040 REMark DEFine PROCedure Video_OFF
23050   REMark POKE 98403,2:REMark Disable MC.STAT
23060 REMark END DEFine Video_OFF
23070 :
23080 REMark DEFine PROCedure Video_ON
23090   REMark POKE 98403,PEEK(SYS_VARS+52)
23100 REMark END DEFine Video_ON
23110 :
23120 DEFine PROCedure Trace
23130   SET_PRIORITY 1:REPeat loop:AT #0,0,0:PRINT #0;BASIC_W%(104);"    ";
23140 END DEFine Trace
23150 :
23160 DEFine PROCedure Line_RANGE
23170   REPeat check_bounds
23180     PRINT "First line number to be analysed? ";:first_line%=EDIT%(100)
23190     PRINT "Final line number? ";:final_line%=EDIT%(32760)
23200     IF final_line%>=first_line% : EXIT check_bounds
23210   END REPeat check_bounds
23220   REPeat check_interval
23230     INPUT "Interval between line numbers? ";:interval%=EDIT%(10)
23240     IF interval%>0 : EXIT check_interval
23250   END REPeat check_interval
23260 END DEFine Line_RANGE
23270 :
23280 DEFine PROCedure Sc_PROFILE
23281   IF COMPILED
23282     WHEN_ERROR 1
23283       IF ERNUM%=-18:PRINT #0;"**** Array full! Press F2. ":RETRY
23285     END_WHEN
23287   END IF 
23290   REPeat restart
23300     Line_RANGE:LIST_TASKS
23310     REPeat who
23320       PRINT"Index (first number) of task to be profiled? ";
23330       task_no%=EDIT%(1)
23340       IF task_no%<0 OR task_no%>PEEK_W(SYS_VARS+98) : NEXT who
23350       task_reg=PEEK_L(PEEK_L(SYS_VARS+104)+4*task_no%)+58
23360       IF task_reg>0 : EXIT who
23370     END REPeat who
23380     DIM table%((final_line%-first_line%) DIV interval%)
23390     in_rom=0:checks=0:last_valid%=final_line%:REMark May start in ROM
23400     RETRY_HERE:REPeat this_run
23410     PRINT \"Press F1 to start profiling and F2 to stop it."
23420     REPeat wait:IF KEYROW(0)=2 : EXIT wait
23430     REPeat poll
23440       IF KEYROW(0)=8 : EXIT poll
23450       line%=PEEK_W(task_reg):checks=checks+1
23460       IF (line%-first_line%) MOD interval%<>0 OR line%<first_line% OR line%>final_line%:line%=last_valid%:in_rom=in_rom+1:ELSE last_valid%=line%
23470       entry%=(line%-first_line%) DIV interval%
23480       table%(entry%)=table%(entry%)+1
23490     END REPeat poll
23500     PRINT "Profiling halted."
23510     REPeat menu
23520       PRINT \"F1: LIST; F3: CONTINUE; F4: RESTART; F5: QUIT."
23530       REPeat poll
23540         key=KEYROW(0):SELect ON key
23550           =2:FOR I=first_line% TO final_line% STEP interval%
23560             i%=I:PRINT table%((i%-first_line%) DIV interval%);" hits on line ";i%
23570             END FOR I
23580             PRINT checks;" checks; ";in_rom;" line-numbers assumed."
23590             NEXT menu
23600           =16:NEXT this_run
23610           =1:NEXT restart
23620           =32:EXIT menu
23630         END SELect 
23640       END REPeat poll
23650     END REPeat menu
23660     PRINT"Profile done.":STOP
23670     END REPeat this_run
23680   END REPeat restart
23690 END DEFine Sc_PROFILE
23700 :
23710 DEFine PROCedure Sb_PROFILE
23721   IF COMPILED
23722     WHEN_ERROR 1
23723       IF ERNUM%=-18:PRINT #0;"**** Array full: Press F2.":RETRY
23725     END_WHEN
23727   END IF 
23728   REPeat restart
23730     Line_RANGE
23740     DIM table%((final_line%-first_line%) DIV interval%)
23750     too_low=0:too_high=0:checks=0
23760     RETRY_HERE:REPeat this_run
23770     PRINT \"Press F1 to start profiling and F2 to stop it."
23780     REPeat wait:IF KEYROW(0)=2 : EXIT wait
23790     REPeat poll1
23800       IF KEYROW(0)=8 : EXIT poll1
23810       line%=BASIC_W%(104):checks=checks+1
23820       IF line%<first_line% : too_low=too_low+1:NEXT poll1
23830       IF line%>final_line% : too_high=too_high+1:NEXT poll1
23840       entry%=(line%-first_line%) DIV interval%
23850       table%(entry%)=table%(entry%)+1
23860     END REPeat poll1
23870     PRINT "Profiling halted."
23880     REPeat menu
23890       PRINT \"F1: LIST; F3: CONTINUE; F4: RESTART; F5: QUIT."
23900       REPeat poll
23910         key=KEYROW(0):SELect ON key
23920           =2:FOR I=first_line% TO final_line% STEP interval%
23930               i%=I:PRINT table%((i%-first_line%) DIV interval%);" hits on line ";i%
23940             END FOR I
23950             PRINT too_low;" too low and ";too_high;" too high of ";checks
23960             NEXT menu
23970           =16:NEXT this_run
23980           =1:NEXT restart
23990           =32:EXIT menu
24000         END SELect 
24010       END REPeat poll
24020     END REPeat menu
24030     PRINT"Profile done.":STOP
24040   END REPeat this_run
24050   END REPeat restart
24060 END DEFine Sb_PROFILE
24090 :
24100 DEFine FuNction Task_TYPE(file$)
24110   LOCal status
24120   status=DEVICE_STATUS(0,file$):REMark Exclusive access needed
24130   IF status>=0 : status=DATASPACE(file$)
24140   RETurn status
24150 END DEFine Task_TYPE
24160 :
24170 DEFine FuNction Basic_VECTOR(n$)
24180   RETurn BASIC_L(BASIC_INDEX%(n$)*8+4+BASIC_L(24))
24190 END DEFine Basic_VECTOR
24200 :
24210 DEFine PROCedure Freeze_SCREEN
24220   POKE SYS_VARS+51,-1
24230 END DEFine Freeze_SCREEN
24240 :
24250 DEFine FuNction Screen_ACTIVE%
24260   RETurn PEEK(SYS_VARS+51)
24270 END DEFine SCREEN_ACTIVE
24280 :
24290 DEFine PROCedure Medium_COPY
24300   LOCal name$(40),in$(40),out$(40),file_length,data_length
24310   LOCal in_dev$(42),out_dev$(42)
24320   INPUT "Source device name (e.g. FLP1_): ";in_dev$
24330   OPEN #5,'pipe_1000':REMark Change for large directories
24340   CONNECT 5 TO 4
24350   DIR #5, in_dev$
24360   CLOSE #5
24370   INPUT #4, name$
24380   INPUT "Destination prefix (e.g. FLP1_): ";out_dev$
24390   PRINT " Do you want to format "; out_dev$;
24400   IF Yea_Or_NAY : FORMAT #0, out_dev$ & name$
24410   INPUT #4, name$ : REMark Ignore sector information
24420   REPeat copier
24430     IF EOF (#4): EXIT copier
24440     INPUT #4, name$
24450     in$= in_dev$ & name$
24460     out$= out_dev$ & name$
24470     IF Read_OK(in$)
24480       file_length=File_SIZE(in$)
24490     ELSE 
24500       PRINT "UNABLE TO READ "; in$
24510       NEXT copier
24520     END IF 
24530     IF DEVICE_STATUS(out$)= -8
24540        PRINT "Delete "; out$;
24550        IF Yea_Or_NAY : DELETE out$ : ELSE NEXT copier
24560     END IF 
24570     IF NOT(Write_OK(out$,file_length))
24580       PRINT "UNABLE TO WRITE "; out$
24590       NEXT copier
24600     END IF 
24610     buffer=ALLOCATION(file_length)
24620     IF buffer <0
24630       PRINT name$; "TOO BIG for available memory."
24640       NEXT copier
24650     END IF 
24660     LBYTES (in$),buffer: data_length=Task_TYPE(in$)
24670     IF data_length>=0
24680       SEXEC (out$),buffer,file_length,data_length
24690     ELSE 
24700       SBYTES (out$),buffer,file_length
24710     END IF 
24720     DEALLOCATE (buffer)
24730   END REPeat copier
24740   CLOSE #4
24750 END DEFine Medium_COPY
24760 :
24770 DEFine PROCedure Re_SAVE(name$)
24780   LOCal status
24790   IF name$="":name$=program_name$
24800   status = DEVICE_STATUS(2,name$)
24810   IF status = -8
24820     DELETE name$: PAUSE 10: SAVE name$
24830     Open_EXTEND 3,name$:PRINT #3;"1 REM"!DATE$!name$:CLOSE #3
24840     program_name$=name$
24850   ELSE 
24860     IF status > 0
24870       SAVE name$
24880       Open_EXTEND 3,name$:PRINT #3;"1 REM"!DATE$!name$:CLOSE #3
24890       program_name$=name$
24900     ELSE 
24910       PRINT #0,"Unable to write "; name$
24920     END IF 
24930   END IF 
24940 END DEFine Re_SAVE
24950 :
24960 DEFine FuNction Task_PRIORITY%(task_num%)
24970    RETurn PEEK(Task_BASE(task_num%)+19)
24980 END DEFine Task_PRIORITY%
24990 :
25000 DEFine FuNction Task_STATUS%(task_num%)
25010    RETurn PEEK_W(Task_BASE(task_num%)+20)
25020 END DEFine Task_STATUS%
25030 :
25040 DEFine PROCedure List_PROCS
25050   LOCal n_ptr
25060   FOR n_ptr=BASIC_L(24) TO BASIC_L(28) STEP 8
25070     IF BASIC_B%(n_ptr)=4 : LIST BASIC_W%(n_ptr+4)
25080   END FOR n_ptr
25090 END DEFine List_PROCS
25100 :
25110 DEFine PROCedure List_EXTRAS(Ch)
25120   LOCal n_ptr,type%
25130   FOR n_ptr=BASIC_L(24) TO BASIC_L(28) STEP 8
25140     type%=BASIC_B%(n_ptr)
25150     IF type%=8:PRINT "Resident Procedure: ";
25155     IF type%=8:PRINT#Ch;"Procedure: ";
25160     IF type%=9:PRINT "Resident Function: ";
25165     IF type%=9:PRINT#Ch;"Function: ";
25170     IF type%=8 OR type%=9:PRINT BASIC_NAME$((n_ptr-BASIC_L(24))/8)
25175     IF type%=8 OR type%=9:PRINT#Ch;BASIC_NAME$((n_ptr-BASIC_L(24))/8)
25180   END FOR n_ptr
25190 END DEFine List_EXTRAS
25200 :
25210 DEFine FuNction Basic_ATTR(chan%)
25220   LOCal ch_id
25230   ch_id=CHANNEL_ID(#chan%)
25240   IF Con_CHANNEL(chan%)
25250     ch_id=ch_id-INT(ch_id/65536)*65536:REMark Extract true channel No
25260     RETurn PEEK_L(PEEK_L(SYS_VARS+120)+4*ch_id):REMark return pointer
25270   ELSE 
25280     RETurn -15:REMark Bad parameter - not a window!
25290   END IF 
25300 END DEFine Basic_ATTR
25310 :
25320 DEFine FuNction Con_CHANNEL(ch%)
25330   LOCal ch_addr,ch_id
25340   ch_id=CHANNEL_ID(#ch%):IF ch_id<0 : RETurn 0
25350   ch_addr=ch_id-INT(ch_id/65536)*65536
25360   ch_addr=PEEK_L(PEEK_L(SYS_VARS+120)+4*ch_addr):REMark Using #0's driver?
25370   IF PEEK_L(ch_addr)<128:RETurn 0
25380   RETurn PEEK_L(PEEK_L(PEEK_L(SYS_VARS+120))+4)=PEEK_L(ch_addr+4)
25390 END DEFine Con_CHANNEL
25400 :
25410 DEFine FuNction Ink_COLOUR%(chan%)
25420   RETurn PEEK(Basic_ATTR(chan%)+70)
25430 END DEFine Ink_COLOUR%
25440 :
25450 DEFine FuNction Paper_COLOUR%(chan%)
25460   RETurn PEEK(Basic_ATTR(chan%)+68)
25470 END DEFine Paper_COLOUR%
25480 :
25490 DEFine FuNction Strip_COLOUR%(chan%)
25500   RETurn PEEK(Basic_ATTR(chan%)+69)
25510 END DEFine Strip_COLOUR%
25520 :
25530 DEFine FuNction Border_COLOUR%(chan%)
25540   RETurn PEEK(Basic_ATTR(chan%)+71)
25550 END DEFine Border_COLOUR%
25560 :
25570 DEFine FuNction Border_WIDTH%(chan%)
25580   RETurn PEEK_W(Basic_ATTR(chan%)+32)
25590 END DEFine Border_WIDTH%
25600 :
25610 DEFine FuNction X_Origin(chan%)
25620   RETurn PEEK_F(Basic_ATTR(chan%)+80)
25630 END DEFine X_Origin
25670 :
25680 DEFine FuNction Y_Origin(chan%)
25690   RETurn PEEK_F(Basic_ATTR(chan%)+74)
25700 END DEFine Y_Origin
25740 :
25750 DEFine FuNction G_Scale(chan%)
25770   RETurn PEEK_F(Basic_ATTR(chan%)+86)
25800 END DEFine G_Scale
25810 :
25820 DEFine FuNction X_Size%(chan%)
25830   RETurn PEEK_W(Basic_ATTR(chan%)+28)
25840 END DEFine X_Size%
25850 :
25860 DEFine FuNction Y_Size%(chan%)
25870   RETurn PEEK_W(Basic_ATTR(chan%)+30)
25880 END DEFine Y_Size%
25890 :
25900 DEFine FuNction Cursor_X%(chan%)
25910   RETurn PEEK_W(Basic_ATTR(chan%)+34)
25920 END DEFine Cursor_X%
25930 :
25940 DEFine FuNction Cursor_Y%(chan%)
25950   RETurn PEEK_W(Basic_ATTR(chan%)+36)
25960 END DEFine Cursor_Y%
25970 :
25980 DEFine FuNction X_Min%(chan%)
25990   RETurn PEEK_W(Basic_ATTR(chan%)+24)
26000 END DEFine X_Min%
26010 :
26020 DEFine FuNction Y_Min%(chan%)
26030   RETurn PEEK_W(Basic_ATTR(chan%)+26)
26040 END DEFine Y_Min%
26050 :
26060 DEFine FuNction Char_ATTR%(chan%)
26070   RETurn PEEK(Basic_ATTR(chan%)+66)
26080 END DEFine Char_ATTR%
26090 :
26100 DEFine FuNction Font1_ADR(chan%)
26110   RETurn PEEK_L(Basic_ATTR(chan%)+42)
26120 END DEFine Font1_ADR
26130 :
26140 DEFine FuNction Font2_ADR(chan%)
26150   RETurn PEEK_L(Basic_ATTR(chan%)+46)
26160 END DEFine Font2_ADR
26170 :
26180 DEFine PROCedure List_FNS
26190   LOCal n_ptr,type%
26200   FOR n_ptr=BASIC_L(24) TO BASIC_L(28) STEP 8
26210    type%=BASIC_B%(n_ptr)
26220    IF type%=5
26230      PRINT BASIC_NAME$((n_ptr-BASIC_L(24))/8) TO 20;
26240      PRINT BASIC_W%(n_ptr+4)
26250    END IF 
26260   END FOR n_ptr
26270 END DEFine List_FNS
26272 :
26273 REMark MUCH MORE IN TURBO_TK_DEMOS 2!
26283 :
26294 DEFine PROCedure List_VARS
26296   LOCal n_ptr,type%,name$(42),type$(28)
26298   FOR n_ptr=BASIC_L(24)+8*BASIC_INDEX%("POSITION") TO BASIC_L(28) STEP 8
26300      type = BASIC_W%(n_ptr)
26302      ptr% = BASIC_W%(n_ptr+2)
26304      IF ptr% > 0
26306        name$ = BASIC_NAME$((n_ptr-BASIC_L(24))/8)
26308        SELect ON type
26310          = 513 : type$ = "a string variable"
26312          = 514 : type$ = "a floating point variable"
26314          = 515 : type$ = "an integer variable"
26316          = 769 : type$ = "a string array"
26318          = 770 : type$ = "a floating point array"
26320          = 771 : type$ = "an integer array"
26322          = 1538 : type$ = "a REPeat loop name"
26324          = 1794 : type$ = "a FOR loop counter"
26326          = REMAINDER : NEXT n_ptr
26328      END SELect 
26330      PRINT name$ TO 16;" is currently " & type$ & "."
26332    END IF 
26334   END FOR n_ptr
26336 END DEFine List_VARS
26338 :
26340 DEFine PROCedure Super_SPOOL
26342   REMark See TURBO Encyclopedia, Page S-6.
26344   LOCal in$(42),out$(42),size,ptr
26346   IMPLICIT% cause
26348   IF COMPILED
26350     WHEN_ERROR 0
26352       cause=ERNUM%
26354       SELect ON cause
26356         =-3: PRINT "Not enough memory to copy " & in$: RETRY
26358         =-16: PRINT "Aaargh: bad or changed medium!"
26360         =-12: PRINT "There's no such device.": RETRY
26362         =-9,-7: PRINT "Unable to load " & in$: RETRY
26364         =-8,-11,-20: PRINT "Unable to save " & out$: RETRY
26366         =REMAINDER : PRINT "Oops ! Error"!cause!"at"!ERLIN%
26368       END SELect 
26370     END_WHEN
26372   END IF 
26374   REPeat Spool:RETRY_HERE:ReadFile:WriteFile
26376 END DEFine Super_SPOOL
26378 :
26380 DEFine PROCedure ReadFile
26382   REMark See TURBO Encyclopedia, Page S-6.
26384   REPeat infile
26386     INPUT "Input file (x to stop): ";in$
26388     IF in$="x": STOP
26390     OPEN_IN #3,in$
26392     SET_POSITION #3,1.6E6 :REMark for mdv
26394     size=POSITION(#3)
26396     CLOSE #3
26398     IF DATASPACE(in$)<0: PRINT "Not data. ": NEXT infile
26400     ptr = ALLOCATION(size)
26402     IF ptr < 0 : PRINT "Too big.": NEXT infile
26404     LBYTES in$,ptr
26406     EXIT infile
26408   END REPeat infile
26410 END DEFine ReadFile
26412 :
26414 DEFine PROCedure WriteFile
26416   INPUT "Output file (x to stop): "; out$
26418   IF out$="x": STOP
26420   SBYTES out$,ptr,size
26422   DEALLOCATE ptr
26424 END DEFine WriteFile
26426 :
26428 DEFine PROCedure Print_MONEY(channel%,amount)
26430   LOCal money$(10)
26432   money$=amount
26434   IF amount<100 THEN money$ ="0" & money$
26436   IF amount<10 THEN money$ ="0" & money$
26438   PRINT #channel%;money$(1 TO LEN(money$)-2);
26440   PRINT #channel%;".";money$(LEN(money$)-1 TO);
26442 END DEFine Print_MONEY
26444 :
26446 DEFine FuNction Input_MONEY(channel%,x%,y%)
26448   LOCal pence, pounds, digit, minus, pointpos, money$(10)
26450     REPeat try
26452       AT #channel%,x%,y%
26454       CLS #channel%,4
26456       money$=EDIT$(#channel%,"0.0",10)
26458       IF LEN(money$)=0
26460         Complain "Entry too brief.":NEXT try
26462       END IF 
26464       minus=(money$(1)="-")
26466       IF minus
26468         IF LEN(money$)=1
26470           Complain "Entry too brief.":NEXT try
26472         END IF 
26474         money$=money$(2 TO LEN(money$))
26476       END IF 
26478       FOR digit = 1 TO LEN(money$)
26480       IF NOT(money$(digit) INSTR ".0123456789")
26482         Complain "Invalid character in entry.":NEXT try
26484       END IF 
26486     END FOR digit
26488     pointpos="." INSTR money$
26490     IF pointpos=0 OR pointpos=LEN(money$)
26492       pounds=money$
26494       pence=0
26496     ELSE 
26498       IF "." INSTR money$(pointpos+1 TO)
26500         Complain "More than one point.":NEXT try
26502       END IF 
26504       pounds = money$(1 TO pointpos-1)
26506       pence = money$(pointpos+1 TO)
26508       IF pence>99 THEN 
26510         Complain "Invalid number after point.":NEXT try
26512       END IF 
26514     END IF 
26516     IF pounds>=1E8
26518       Complain "Number too large.":NEXT try
26520     END IF 
26522     IF minus
26524       RETurn -(pounds*100+pence)
26526     ELSE 
26528       RETurn pounds*100+pence
26530     END IF 
26532   END REPeat try
26534 END DEFine Input_MONEY
26536 :
26538 DEFine PROCedure Complain(message$)
26540   REMark See TURBO Encyclopedia, Page L-8.
26542   AT #channel%,0,0
26544   CLS #channel%,3
26546   PRINT #channel%;"**** "&message$;
26548 END DEFine Complain
26550 :
26552 DEFine PROCedure Ram_SPEED
26554   base=RESPR(16):RESTORE 26562:REMark May need RENUMbering
26556   FOR I=base TO base+14 STEP 2:READ v:POKE_W I,v
26558   t=DATE:CALL base
26560   PRINT "Speed factor ";DATE-t
26562   DATA 28771,29439,20937,-2,20936,-8,28672,20085
26564 END DEFine Ram_SPEED
26566 :
26568 DEFine PROCedure Turbo_TRACE
26570   REMark Multi-tasking line and DATASPACE monitor!
26572   LIST_TASKS
26574   REPeat who
26576     PRINT \"Index (first number) of TURBO task? ";
26578     task_no%=EDIT%(1)
26581     IF task_no%<0 OR task_no%>PEEK_W(SYS_VARS+98) : NEXT who
26582       task_start=PEEK_L(PEEK_L(SYS_VARS+104)+4*task_no%)
26584     IF task_start>0
26586       bv_tgbas=PEEK_L(task_start+188)
26588       IF bv_tgbas=0 : EXIT who
26590     END IF 
26592   END REPeat who
26594   PRINT #0;"LINE/DATASPACE ";
26596   REPeat what
26598     space=PEEK_L(task_start+68)-PEEK_L(task_start+80)
26600     line%=PEEK_W(task_start+58)
26602     IF space>0 AND space<PEEK_L(task_start) AND line%>0
26604       AT #0,0,15:PRINT #0;line%&"/"&space&"     ";
26606     END IF 
26608   END REPeat what
26610 END DEFine Turbo_TRACE
26612 :
26614 DEFine PROCedure V_Dim1%(channel%,name$,max_sub1)
26616   LOCal file_length%
26618   file_length%=(max_sub1+1)*2
26620   IF Write_OK(name$,file_length%)=-11
26622     PRINT #0;"Device full."
26624   ELSE 
26626     OPEN_NEW #channel%,name$
26628     V_Extend channel%,file_length%-1
26630   END IF 
26632 END DEFine V_Dim1%
26634 :
26636 DEFine FuNction V_Read1%(channel%,sub1%)
26638   IF sub1% < 0 : PRINT #0,"Negative subscript.": STOP
26640   SET_POSITION #channel%, sub1%*2
26642   IF POSITION(#channel%)= (sub1%*2)
26644     RETurn GET%(channel%)
26646   ELSE 
26648     PRINT #0,"Bad subscript "; sub1%
26650     STOP
26652   END IF 
26654 END DEFine V_Read1%
26656 :
26658 DEFine PROCedure V_Set1%(channel%,sub1%,value%)
26660   IF sub1% < 0 : PRINT #0,"Negative subscript.":STOP
26662   SET_POSITION #channel%, sub1%*2
26664   IF POSITION(#channel%) = sub1%*2
26666     PRINT #channel%,INTEGER$(value%);
26668   ELSE 
26670     PRINT #0,"Bad subscript "; sub1%: STOP
26672   END IF 
26674 END DEFine V_Set1%
26676 :
26678 DEFine PROCedure V_Extend(channel%,end_position)
26680   REPeat extend_file
26682     IF POSITION(#channel%)+100 < end_position
26684       PRINT #channel%, FILL$ (CHR$(0),100);
26686     ELSE 
26688        PRINT #channel%,(FILL$ (CHR$(0),end_position-POSITION(#channel%)));
26690        EXIT extend_file
26692     END IF 
26694   END REPeat extend_file
26696 END DEFine V_Extend
26698 :
26700 DEFine PROCedure V_Open_IO(channel%,filename$)
26702   IF DEVICE_STATUS(-1,filename$) = -8
26704     OPEN #channel%,filename$
26706   ELSE 
26708     PRINT #0,filename$ ; "cannot be opened for I/O."
26710   END IF 
26712 END DEFine V_Open_IO
26714 :
26716 DEFine PROCedure V_Open_IN(channel%,filename$)
26718   LOCal status
26720   status=DEVICE_STATUS(1,filename$)
26722   IF status = -8 OR status = -20
26724     OPEN_IN #channel%,filename$
26726   ELSE 
26728     PRINT #0,filename$ ; " connot be opened for reading."
26730   END IF 
26732 END DEFine V_Open_IN
26734 :
26736 DEFine PROCedure V_Dim1(channel%,filename$,max_sub1)
26738   LOCal file_length
26740   file_length = (max_sub1+1)*6
26742   IF Write_OK(filename$,file_length)=-11
26744     PRINT #0,"Device full."
26746     STOP
26748   ELSE 
26750     OPEN_NEW #channel%,filename$
26752     V_Extend channel%,file_length-1
26754   END IF 
26756 END DEFine V_Dim1
26758 :
26760 DEFine PROCedure V_Set1(channel%,sub1%,value)
26762   IF sub1% < 0 : PRINT #0,"Negative subscript.": STOP
26764   SET_POSITION #channel%,sub1%*6
26766   IF POSITION(#channel%) = sub1%*6
26768     PRINT #channel%, FLOAT$(value);
26770   ELSE 
26772     PRINT #0,"Bad subscript "; sub1%
26774     STOP
26776   END IF 
26778 END DEFine V_Set1
26780 :
26782 DEFine FuNction V_Read1(channel%,sub1%)
26784   IF sub1% < 0 : PRINT #0,"Negative subscript.": STOP
26786   SET_POSITION #channel%,sub1%*6
26788   IF POSITION(#channel%) = sub1%*6
26790     RETurn GETF(channel%)
26792   ELSE 
26794     PRINT #0,"Bad subscript "; sub1%
26796     STOP
26798   END IF 
26800 END DEFine V_Read1
26802 :
26804 DEFine PROCedure V_Dim2%(channel%,filename$,max_sub1,max_sub2)
26806   LOCal file_length
26808   file_length= (max_sub1+1)*(max_sub2+1)*2
26810   IF Write_OK(filename$,file_length)=-11
26812     PRINT #0,"Device full."
26814     STOP
26816   ELSE 
26818     OPEN_NEW #channel%,filename$
26820     V_Extend channel%,file_length
26822   END IF 
26824 END DEFine V_Dim2%
26826 :
26828 DEFine PROCedure V_Set2%(channel%,sub1%,sub2%,value%,max_sub2)
26830   LOCal pos
26832   IF (sub1%<0) OR (sub2%<0): PRINT #0,"Negative subscript.":STOP
26834   pos=(sub1%*(max_sub2+1)+sub2%)*2
26836   SET_POSITION #channel%,pos
26838   IF POSITION(#channel%)=pos
26840     PRINT #channel%, INTEGER$(value%);
26842   ELSE 
26844     PRINT #0,"Bad subscript ";sub1%,sub2%: STOP
26846   END IF 
26848 END DEFine V_Set2%
26850 :
26852 DEFine FuNction V_Read2%(channel%,sub1%,sub2%,max_sub2)
26854   LOCal pos
26856   IF (sub1% < 0) OR (sub2% < 0) : PRINT #0,"Negative subscript.":STOP
26858   pos=max_sub2:pos=(sub1%*(pos+1)+sub2%)*2
26860   SET_POSITION #channel%,pos
26862   IF POSITION(#channel%)=pos
26864     RETurn GET%(channel%)
26866   ELSE 
26868     PRINT #0,"Bad subscript "; sub1%,sub2%: STOP
26870   END IF 
26872 END DEFine V_Read2%
26874 :
26876 DEFine PROCedure V_Dim2(channel%,filename$,max_sub1,max_sub2)
26878   LOCal file_length
26880   file_length= (max_sub1+1)*(max_sub2+1)*6
26882   IF Write_OK(filename$,file_length)= -11
26884     PRINT #0,"Device full."
26886     STOP
26888   ELSE 
26890     OPEN_NEW #channel%,filename$
26892     V_Extend channel%,file_length
26894   END IF 
26896 END DEFine V_Dim2
26898 :
26900 DEFine PROCedure V_Set2(channel%,sub1%,sub2%,value,max_sub2)
26902   LOCal pos
26904   IF (sub1%<0) OR (sub2%<0): PRINT #0,"Negative subscript.":STOP
26906   pos=(sub1%*(max_sub2+1)+sub2%)*6
26908   SET_POSITION #channel%,pos
26910   IF POSITION(#channel%)=pos
26912     PRINT #channel%,FLOAT$(value);
26914   ELSE 
26916     PRINT #0,"Bad subscript ";sub1%,sub2%: STOP
26918   END IF 
26920 END DEFine V_Set2
26922 :
26924 DEFine FuNction V_Read2(channel%,sub1%,sub2%,max_sub2)
26926   LOCal pos
26928   IF (sub1%<0) OR (sub2%<0):PRINT #0,"Negative subscript.":STOP
26930   pos=(sub1%*(max_sub2+1)+sub2%)*6
26932   SET_POSITION #channel%,pos
26934   IF POSITION(#channel%)=pos
26936     RETurn GETF(channel%)
26938   ELSE 
26940     PRINT #0,"Bad subscript ";sub1%,sub2%: STOP
26942   END IF 
26944 END DEFine V_Read2
26946 :
26948 DEFine PROCedure V_Dim3%(channel%,filename$,max_sub1,max_sub2,max_sub3)
26950   LOCal file_length
26952   file_length = (max_sub1+1)*(max_sub2+1)*(max_sub3+1)*2
26954   IF Write_OK(filename$,file_length)=-11
26956     PRINT #0,"Device full."
26958     STOP
26960   ELSE 
26962     OPEN_NEW #channel%,filename$
26964     V_Extend channel%,file_length
26966   END IF 
26968 END DEFine V_Dim3%
26970 :
26972 DEFine PROCedure V_Set3%(channel%,sub1%,sub2%,sub3%,value%,max_sub2,max_sub3)
26974   LOCal pos
26976   IF (sub1%<0) OR (sub2%<0) OR (sub3%<0): PRINT #0,"Negative subscript.":STOP
26978   pos=(sub1%*(max_sub2+1)*(max_sub3+1)+sub2%*(max_sub3+1)+sub3%)*2
26980   SET_POSITION #channel%,pos
26982   IF POSITION(#channel%)=pos
26984     PRINT #channel%,INTEGER$(value%);
26986   ELSE 
26988     PRINT #0,"Bad subscript "; sub1%,sub2%,sub3%: STOP
26990   END IF 
26992 END DEFine V_Set3%
26994 :
26996 DEFine FuNction V_Read3%(channel%,sub1%,sub2%,sub3%,max_sub2,max_sub3)
26998   LOCal pos
27000   IF (sub1% <0) OR (sub2% <0) OR (sub3% <0): PRINT #0,"Negative subscript.":STOP
27002   pos=(sub1%*(max_sub2+1)*(max_sub3+1)+sub2%*(max_sub3+1)+sub3%)*2
27004   SET_POSITION #channel%,pos
27006   IF POSITION(#channel%)=pos
27008     RETurn GET%(channel%)
27010   ELSE 
27012     PRINT #0,"Bad subscript ";sub1%,sub2%,sub3%: STOP
27014   END IF 
27016 END DEFine V_Read3%
27018 :
27020 DEFine PROCedure V_Dim3(channel%,filename$,max_sub1,max_sub2,max_sub3)
27022   LOCal file_length
27024   file_length=((max_sub1+1)*(max_sub2+1)*(max_sub3))*6
27026   IF Write_OK(filename$,file_length)=-11
27028     PRINT #0,"Device full."
27030     STOP
27032   ELSE 
27034     OPEN_NEW #channel%,filename$
27036     V_Extend channel%,file_length
27038   END IF 
27040 END DEFine V_Dim3
27042 :
27044 DEFine PROCedure V_Set3(channel%,sub1%,sub2%,sub3%,value,max_sub2,max_sub3)
27046   LOCal pos
27048   IF (sub1% <0) OR (sub2% <0) OR (sub3% <0):PRINT #0,"Negative subscript.":STOP
27050   pos=(sub1%*(max_sub2+1)*(max_sub3+1)+sub2%*(max_sub3+1)+sub3%)*6
27052   SET_POSITION #channel%,pos
27054   IF POSITION(#channel%)=pos
27056     PRINT #channel%, FLOAT$(value);
27058   ELSE 
27060     PRINT #0,"Bad subscript ";sub1%,sub2%,sub3%: STOP
27062   END IF 
27064 END DEFine V_Set3
27066 :
27068 DEFine FuNction V_Read3(channel%,sub1%,sub2%,sub3%,max_sub2,max_sub3)
27070   LOCal pos
27072   IF (sub1%<0) OR (sub2%<0) OR (sub3%<0) :PRINT #0,"Negative subscript.":STOP
27074   pos=(sub1%*(max_sub2+1)*(max_sub3+1)+sub2%*(max_sub3+1)+sub3%)*6
27076   SET_POSITION #channel%,pos
27078   IF POSITION(#channel%)=pos
27080     RETurn GETF(channel%)
27082   ELSE 
27084     PRINT #0,"Bad subscript ";sub1%,sub2%,sub3%: STOP
27086   END IF 
27088 END DEFine V_Read3
27090 :
27092 DEFine PROCedure V_Dim2$(channel%,filename$,max_sub1,max_length%)
27094   LOCal file_length
27096   file_length=(max_sub1+1)*(max_length%+2)
27098   IF Write_OK(filename$,file_length)=-11
27100     PRINT #0,"Device full."
27102     STOP
27104   ELSE 
27106     OPEN_NEW #channel%,filename$
27108     V_Extend channel%,file_length
27110   END IF 
27112 END DEFine V_Dim2$
27114 :
27116 DEFine PROCedure V_Set2$(channel%,sub1%,text$,max_length%)
27118   LOCal pos
27120   IF sub1%<0 :PRINT #0,"Negative subscript.":STOP
27122   pos=sub1%:pos=pos*(max_length%+2)
27124   SET_POSITION #channel%,pos
27126   IF POSITION(#channel%)=pos
27128     PRINT #channel%,STRING$(text$);
27130   ELSE 
27132     PRINT #0,"Bad subscript "; sub1% : STOP
27134   END IF 
27136 END DEFine V_Set2$
27138 :
27140 DEFine FuNction V_Read2$(channel%,sub1%,max_length%)
27142   LOCal pos
27144   IF sub1%<0 : PRINT #0,"Negative subscript.": STOP
27146   pos=sub1%:pos=pos*(max_length%+2)
27148   SET_POSITION #channel%,pos
27150   IF POSITION(#channel%)=pos
27152     RETurn GET$(channel%)
27154   ELSE 
27156     PRINT #0,"Bad subscript ";sub1%: STOP
27158   END IF 
27160 END DEFine V_Read2$
27162 :
27164 DEFine PROCedure V_Dim3$(channel%,filename$,max_sub1,max_sub2,max_length%)
27166   LOCal file_length
27168   file_length=(max_sub1+1)*(max_sub2+1)*(max_length%+2)
27170  IF Write_OK(filename$,file_length)=-11
27172     PRINT #0,"Device full."
27174     STOP
27176   ELSE 
27178     OPEN_NEW #channel%,filename$
27180     V_Extend #channel%,file_length
27182   END IF 
27184 END DEFine V_Dim3$
27186 :
27188 DEFine PROCedure V_Set3$(channel%,sub1%,sub2%,text$,max_sub2,max_length%)
27190   LOCal pos
27192   IF (sub1% < 0) OR (sub2% < 0): PRINT #0,"Negative subscript.":STOP
27194   pos=(sub1%*(max_sub2+1)+ sub2%)*(max_length%+2)
27196   SET_POSITION #channel%,pos
27198   IF POSITION(#channel%)=pos
27200     PRINT #channel%,STRING$(text$);
27202   ELSE 
27204     PRINT #0,"Bad subscript ";sub1%,sub2%
27206     STOP
27208   END IF 
27210 END DEFine V_Set3$
27212 :
27214 DEFine FuNction V_Read3$(channel%,sub1%,sub2%,max_sub2,max_length%)
27216   LOCal pos
27218   IF (sub1% < 0) OR (sub2% < 0): PRINT #0,"Negative subscript.":STOP
27220   pos=(sub1%*(max_sub2+1)+sub2%)*(max_length%+2)
27222   SET_POSITION #channel%,pos
27224   IF POSITION(#channel%)=pos
27226     RETurn GET$(channel%)
27228   ELSE 
27230     PRINT #0,"Bad subscript ";sub1%,sub2%: STOP
27232   END IF 
27234 END DEFine V_Read3$
27236 :
27238 DEFine PROCedure Force_FONT
27240   LOCal font1_ptr,font1_addr,newfont_size,newfont_addr,alloc_flag
27242     DIM name$(42)
27244     REPeat get_in
27246       INPUT "Enter font filename "; name$
27248       IF Read_OK(name$): EXIT get_in
27250     END REPeat get_in
27252     newfont_size= File_SIZE(name$)
27254     newfont_addr= ALLOCATION(newfont_size)
27256     alloc_flag=newfont_addr<0
27258     IF alloc_flag:PRINT "No RAM!":STOP
27260     LBYTES ""&name$,newfont_addr:REMark "" fixes interpreter bug in some versions!
27262     FOR I=PEEK_L(SYS_VARS+120) TO 4*PEEK_W(SYS_VARS+114)+PEEK_L(SYS_VARS+120) STEP 4
27264       IF PEEK_L(I)>0
27266         IF PEEK_L(PEEK_L(PEEK_L(SYS_VARS+120))+4) = PEEK_L(PEEK_L(I)+4)
27268           font1_ptr= PEEK_L(I)+42
27270           font1_addr= PEEK_L(font1_ptr)
27272           POKE_L font1_ptr,newfont_addr
27274          PRINT "Do you want this font change ";
27276          IF Yea_Or_NAY
27278             alloc_flag=1
27280             NEXT I
27282          ELSE 
27284             POKE_L font1_ptr,font1_addr
27286          END IF 
27288        END IF 
27290      END IF 
27292    END FOR I
27294   IF alloc_flag=0:DEALLOCATE newfont_addr
27296 END DEFine Force_FONT
27298 :
27300 DEFine PROCedure Piped_MUSIC
27302   LOCal music$(200)
27304   IF CHANNEL_ID(#15)<0:PRINT #0,"No input pipe.":STOP
27306   REPeat replay
27308     IF EOF(#15):PRINT #0,"No more music.":EXIT replay
27310     INPUT #15,music$:Play_TUNE music$
27312   END REPeat replay
27314 END DEFine Piped_MUSIC
27316 :
27318 DEFine PROCedure Plain_ENGLISH
27320   DIM k$(80)
27322   k$=VER$:IF k$="JM" OR k$="AH":PRINT #0,"Wrong ROM!":STOP
27324   x=ALLOCATION(1024)
27326   RESTORE 27356:REMark May need RENUMbering
27328   POKE_W x,19195
27330   t=x+60
27332   FOR a=2 TO 58 STEP 2
27334     READ k$
27336     IF a<56
27338       IF a<>44:k$=k$&CHR$(10)
27340       IF a=48:READ t$:k$=k$&t$&CHR$(10)
27342       k$=INTEGER$(LEN(k$)) & k$
27344     END IF 
27346     POKE_W x+a,t-x
27348     POKE$ t,k$
27350     t=t+LEN(k$)+(LEN(k$) MOD 2)
27352   END FOR a
27354   TRA 0,x
27356   DATA "**** I hadn't finished!","**** I'm not doing that task."
27358   DATA "**** My mind's gone blank!","**** Don't be ridiculous!"
27360   DATA "**** I've forgotten what you were saying..."
27362   DATA "**** I'm not using that channel.","**** I can't find that."
27364   DATA "**** It's already there!","**** I'm already using that!"
27366   DATA "**** There's no more data."
27368   DATA "**** I can't fit anything else on."
27370   DATA "**** That's not a command or device name."
27372   DATA "**** Fix the RS-232 parity, dummy!"
27374   DATA "**** Sorry - I can't format that.","**** Pardon?"
27376   DATA "**** I've got this terrible pain in my drive!"
27378   DATA "**** I can't work that out."
27380   DATA "**** Extremely cosmic number generated!"
27382   DATA "**** I don't know how to do that."
27384   DATA "**** It's ignoring me."
27386   DATA "**** Shome mishtake, shurely?","**** Check line "," lumps"
27388   DATA "F1...Thingum","F2...Doodah"," Simon Goodwin & SRL (retd)"
27390   DATA "I can't trap that.","I've forgotten what I was doing."
27392   DATA "SunMonTueWedThuFriSat","JanFebMarAprMayJunJulAugSepOctNovDec"
27394 END DEFine Plain_ENGLISH
27396 REMark See TURBO Encyclopedia, Page S-6.
27398 :
27400 DEFine PROCedure Setup_MUSIC
27402   LOCal I
27404   DIM note_index%(6):REMark Next lines may need RENUMbering
27406   RESTORE 27418:FOR I=0 TO 6:READ note_index%(I)
27408   RESTORE 27420:READ top_note%,silence%,length%
27410   DIM note_value%(top_note%)
27412   FOR I=0 TO top_note%:READ note_value%(I)
27414   REMark See TURBO Encyclopedia, Pages U-20 to 22.
27416   REMark For rising scale A-G use 0,2,3,5,7,8,10 below
27418   DATA 9,11,0,2,4,5,7:REMark Gives scale C,D,E,F,G,A,B,C2 etc.
27420   DATA 24,2,9, 124,116,108,102,96,90,85,80,75,70
27422   DATA 65,61,57,54,50,47,44,41,38,35,32,30,28,26,24
27424 END DEFine Setup_MUSIC
27426 :
27428 DEFine PROCedure Play_TUNE(tune$)
27430   LOCal pos%,param,par%(6),next_code
27432   pos%=0
27434   Bump_POSITION
27436   REPeat scan_tune
27438     IF pos%>LEN(tune$) THEN RETurn 
27440     SELect ON next_code
27442       =32,44:Bump_POSITION:REMark Ignore spaces and commas
27444       =65 TO 71:Parse_N_PLAY next_code-65:REMark A to G
27446       =97 TO 103:Parse_N_PLAY next_code-97:REMark a to g
27448       =81,113:RETurn :REMark Q is for Quit
27450       =82,114:pos%=0:Bump_POSITION:REMark REPEAT
27452       =83,115:silence%=Extract_INT%
27454       =76,108:length%=Extract_INT%
27456       =88,120:REMark eXtended specification
27458         FOR param=0 TO 6:par%(param)=Extract_INT%:Bump_POSITION
27460         BEEP 0,par%(0),par%(1),par%(2),par%(3),par%(4),par%(5),par%(6)
27462         SUSPEND_TASK length%:BEEP:SUSPEND_TASK silence%
27464       =REMAINDER :PRINT #0;"Unexpected character in tune: ";:Bum_NOTE
27466     END SELect 
27468   END REPeat scan_tune
27470 END DEFine Play_TUNE
27472 :
27474 DEFine FuNction Extract_INT%
27476   LOCal start_pos%
27478   start_pos%=-1
27480   IF next_code<48 OR next_code>57:Bump_POSITION
27482   REPeat delimit_number
27484     IF pos%>LEN(tune$) OR next_code<48 OR next_code>57
27486       IF start_pos%>0
27488         RETurn tune$(start_pos% TO pos%)
27490       ELSE 
27492         PRINT #0;"Tune value expected: ";:Bum_NOTE
27494       END IF 
27496     ELSE 
27498       IF start_pos%<0:start_pos%=pos%
27500     END IF 
27502     Bump_POSITION
27504   END REPeat delimit_number
27506 END DEFine Extract_INT%
27508 :
27510 DEFine PROCedure Bump_POSITION
27512   pos%=pos%+1
27514   IF pos%<=LEN(tune$):next_code=CODE(tune$(pos% TO pos%))
27516 END DEFine Bump_POSITION
27518 :
27520 DEFine PROCedure Parse_N_PLAY(index%)
27522   LOCal root%
27524   root%=note_index%(index%)
27526   Bump_POSITION
27528   SELect ON next_code=49 TO 51:root%=root%+12*(next_code-49):Bump_POSITION
27530   SELect ON next_code
27532     =35:root%=root%+1:Bump_POSITION:REMark Sharp
27534     =66,98:root%=root%-1:Bump_POSITION:REMark Flat
27536   END SELect 
27538   IF root%<0 OR root%>top_note%
27540     PRINT #0;"Pitch out of range: ";:Bum_NOTE
27542   ELSE 
27544     BEEP 0,note_value%(root%):SUSPEND_TASK length%
27546     BEEP:SUSPEND_TASK silence%
27548   END IF 
27550 END DEFine Parse_N_PLAY
27552 :
27554 DEFine PROCedure Bum_NOTE
27556   IF pos%>LEN(tune$):pos%=LEN(tune$)
27558   SUSPEND_TASK 35:BEEP 10000,30,250,30,1
27560   PRINT #0;tune$(1 TO pos%);" ?":STOP
27562 END DEFine Bum_NOTE
27564 :
27566 DEFine PROCedure Data_TRACE
27568   REMark TRACE for SUPERCHARGEd tasks
27570   LIST_TASKS
27572   REPeat who
27574     PRINT"Index (first number) of task to be profiled? ";
27576     task_no%=EDIT%(1)
27578     IF task_no%<0 OR task_no%>PEEK_W(SYS_VARS+98) : NEXT who
27580     task_start=PEEK_L(PEEK_L(SYS_VARS+104)+4*task_no%)
27582     IF task_start>0
27584       bv_tgbas=PEEK_L(task_start+188)
27586       IF ((bv_tgbas=65532) OR (bv_tgbas=65533)): EXIT who
27588     END IF 
27590   END REPeat who
27592   PRINT #0;"DATASPACE ";
27594   REPeat what
27596     base=PEEK_L(task_start+80)
27598     space=PEEK_L(task_start+68)+PEEK_L(task_start+88)-base
27600     IF space>0 AND space<PEEK_L(task_start)
27602       AT #0,0,10:PRINT #0;space;"     ";
27604     END IF 
27606   END REPeat what
27608 END DEFine Data_TRACE
27610 :
27612 DEFine PROCedure Open_EXTEND(chan%,name$)
27614   OPEN #chan%,name$
27616   SET_POSITION #chan%,1.6E6:REMark Max. safe file size 6Mb!
27618 END DEFine Open_EXTEND
27620 :
27622 DEFine PROCedure Tidy_MEDIUM
27624   LOCal name$(42),device$(42),count%
27626   INPUT "Tidy which device (e.g. FLP1_) ";device$
27628   count%=0
27630   OPEN #5,pipe_1000:REMark Max. directory size allowed
27632   CONNECT 5 TO 4
27634   DIR #5, device$
27636   CLOSE #5
27638   INPUT #4,name$
27640   CLS
27642   PRINT "Medium name "; name$
27644   INPUT #4 , name$   : REMark sector information ignore ?
27646   REPeat get_files
27648     IF EOF (#4) : EXIT get_files
27650     INPUT #4, name$
27652     PRINT "Delete ";name$;
27654     IF Yea_Or_NAY : DELETE device$ & name$ :count%=count%+1
27656   END REPeat get_files
27658   PRINT "end of directory ";device$
27660   PRINT count% ; " file";
27662   IF count%<>1:PRINT"s deleted.":ELSE PRINT " deleted."
27664   PRINT
27666   PRINT "Do you want to see the directory now ";
27668   IF Yea_Or_NAY :PRINT : DIR device$
27670 END DEFine Tidy_MEDIUM
27672 :
27674 DEFine PROCedure Rotate_L(first_line%,lines%,cols%)
27676   LOCal first_bit,j
27678   IF first_line%<0 OR first_line%+lines%>256 OR cols%<1 OR cols%>64:PRINT #0,"AAARGH!":STOP
27680   first_bit=ALLOCATION(cols%*2)
27682   FOR I = first_line% TO first_line%+lines%-1
27684     j = I*128
27686     MOVE_MEMORY 131072 + j TO first_bit, cols%*2
27688     MOVE_MEMORY (131072 + j + cols%*2) TO 131072 + j , 128- cols%*2
27690     MOVE_MEMORY first_bit TO 131072 + j + (128 - cols%*2),cols%*2
27692   END FOR I
27694   DEALLOCATE first_bit
27696 END DEFine Rotate_L
27698 :
27700 DEFine PROCedure Rotate_R(first_line%,lines%,cols%)
27702   LOCal last_bit,j
27704   IF first_line%<0 OR first_line%+lines%>256 OR cols%<1 OR cols%>64:PRINT #0,"AAARGH!":STOP
27706   last_bit=ALLOCATION(cols%*2)
27708   FOR I = first_line% TO lines%+first_line%-1
27710     j= I*128
27712     MOVE_MEMORY 131072 + j +128 - (cols%*2) TO last_bit , cols%*2
27714     MOVE_MEMORY 131072+j TO 131072+j+cols%*2, -(128-cols%*2)
27716     MOVE_MEMORY last_bit TO 131072 + j,-cols%*2
27718   END FOR I
27720   DEALLOCATE last_bit
27722 END DEFine Rotate_R
27724 :
27726 DEFine PROCedure Wild_PURGE
27728   LOCal name$(42),count%,match$(42),device$(42)
27730   INPUT "Device name (e.g. FLP1_): ";device$
27732   INPUT "String to be matched: ";match$
27734   count%=0
27736   OPEN #5, pipe_1000
27738   CONNECT 5 TO 4
27740   DIR #5, device$
27742   CLOSE #5
27744   INPUT #4, name$
27746   CLS
27748   PRINT "Medium name "; name$
27750   INPUT #4, name$ : REMark sector information - ignore ?
27752   REPeat get_files
27754     IF EOF(#4) : EXIT get_files
27756     INPUT #4, name$
27758     IF match$ INSTR name$=0 : NEXT get_files
27760     PRINT "Delete "; name$ ;
27762     IF Yea_Or_NAY : DELETE device$ & name$ : count% = count% + 1
27764   END REPeat get_files
27766   PRINT "End of directory ";device$
27768   PRINT count% ;" file";
27770   IF count%<>1:PRINT "s deleted.":ELSE PRINT " deleted."
27772 END DEFine Wild_PURGE
27774 :
27776 DEFine FuNction Built_Wndo(ch%,a%,b%,c%,d%)
27778   LOCal _base, first_col%, bytes%, scr_base
27780   first_col% = 2*(c% DIV 8)
27782   bytes% = 2*((c%+a%+6) DIV 8) - first_col%
27784   scr_base = 128*d% + first_col% + 131072
27786   _base = bytes% : _base = _base * b% + 16
27788   _base = ALLOCATION(_base) : IF _base < 0 : RETurn _base
27790   POKE_L _base,   scr_base
27792   POKE_W _base+4, bytes%
27794   POKE_W _base+6, a%
27796   POKE_W _base+8, b%
27798   POKE_W _base+10,c%
27800   POKE_W _base+12,d%
27802   Move_RAM (scr_base), _base+16, 128, 0, bytes%, b%
27804   OPEN #ch%,'scr' : WINDOW #ch%,a%,b%,c%,d% : CLS #ch%
27806   RETurn _base
27808 END DEFine 
27810 :
27812 DEFine PROCedure Close_Wndo(ch%, _base)
27814   LOCal a%, b%, bytes%, scr_base
27816   CLOSE #ch%
27818   scr_base = PEEK_L(_base)
27820   bytes%   = PEEK_W(_base+4)
27822   a%       = PEEK_W(_base+6)
27824   b%       = PEEK_W(_base+8)
27826   Move_RAM _base+16, (scr_base), 0, 128, bytes%, b%
27828   DEALLOCATE _base
27830 END DEFine 
27832 :
27834 DEFine PROCedure Move_RAM(srce,dest,step1,step2,bytes%,lines%)
27836   LOCal ii
27838   FOR ii = 1 TO lines%
27840     MOVE_MEMORY srce TO dest, bytes%
27842     IF step1 : srce = srce+step1 : ELSE : srce = srce+bytes%
27844     IF step2 : dest = dest+step2 : ELSE : dest = dest+bytes%
27846   END FOR ii
27848 END DEFine 
27850 :
27852 REMark IMPLICIT% pos
27854 DEFine FuNction Format_FP$(floatval,fld_width%,dec_places%)
27856   LOCal val$(100),tmp$(100),zero$(32),space$(32),star$(32),pos,exp_ptr%,chk%
27858   zero$=FILL$("0",32)
27860   space$=FILL$(" ",32)
27862   star$=FILL$("*",32)
27864   IF fld_width%<0 OR fld_width%>30:RETurn "?"
27866   IF dec_places%<0 OR dec_places%>30:RETurn "?"
27868   val$=floatval
27870   IF val$(1)="-":val$=val$(2 TO LEN(val$))
27872   pos="E" INSTR val$
27874   IF pos=0
27876     exp_ptr%=0
27878   ELSE 
27880     exp_ptr%=val$(pos+1 TO LEN(val$))
27882     val$=val$(1 TO pos-1)
27884   END IF 
27886   pos="." INSTR val$
27888   SELect ON pos
27890     =0:pos=LEN(val$)+1
27892     =1:val$=val$(2 TO LEN(val$))
27894     =REMAINDER :
27896       val$=val$(1 TO pos-1) & val$(pos+1 TO LEN(val$))
27898   END SELect 
27900   val$=zero$&val$&zero$
27902   pos=32+pos+exp_ptr%
27904   exp_ptr%=pos+dec_places%
27906   IF val$(exp_ptr%)>"4"
27908    val$=val$(1 TO exp_ptr%-1)&"9"&val$(exp_ptr%+1 TO LEN(val$))
27910   END IF 
27912   REPeat did_it_overflow
27914     chk%=1+val$(exp_ptr%):tmp$="OFF"
27916     IF chk%=10:chk%=0:tmp$="ON"
27918     val$=val$(1 TO exp_ptr%-1)&chk%&val$(exp_ptr%+1 TO LEN(val$))
27920   IF tmp$="OFF":EXIT did_it_overflow
27922   exp_ptr%=exp_ptr%-1
27924   END REPeat did_it_overflow
27926   tmp$=val$(1 TO pos-1)
27928   IF dec_places%>0:tmp$=tmp$&"."&val$(pos TO pos+dec_places%-1)
27930   chk%=1
27932   REPeat kill_leading_zeroes
27934     IF tmp$(chk%)<>"0" OR chk%=LEN(tmp$):EXIT kill_leading_zeroes
27936     chk%=chk%+1
27938   END REPeat kill_leading_zeroes
27940   IF pos=chk%:chk%=chk%-1
27942   tmp$=tmp$(chk% TO LEN(tmp$))
27944   IF floatval<0 AND tmp$<>"0":tmp$="-"&tmp$
27946   val$=space$&tmp$
27948   IF (pos-chk%)>(fld_width%-dec_places%-("."INSTR val$>0)-(floatval<0))
27950     val$=star$(1 TO fld_width%)
27952   ELSE 
27954     val$=val$(LEN(val$)-fld_width%+1 TO LEN(val$))
27956   END IF 
27958   RETurn val$
27960 END DEFine Format_FP$
27962 :
